                segment code

Animate:        LD      IX,AnimList-pLinkAnim
AnimLoop:       LD      L,(IX+pLinkAnim+$00)
                LD      H,(IX+pLinkAnim+$01)
                LD      A,H
                OR      L
                RET     Z
                PUSH    HL
                PUSH    HL
                POP     IX
                LD      L,(IX+pAnimRout+$00)
                LD      H,(IX+pAnimRout+$01)
                CALL    DealWAnim
                POP     IX
                JP      AnimLoop

CallHL2         JP      (HL)

DealWAnim:      LD      C,(IX+pXDraw)
                LD      A,(IX+pWidth)
                ADD     A,C
                LD      B,A
                LD      E,(IX+pYDraw)
                LD      D,(IX+pHeight)
                LD      A,D
                ADD     A,E
                LD      D,A
                PUSH    BC
                PUSH    DE
                PUSH    IX

                CALL    CallHL2

                POP     IX
                POP     BC
                JR      C,NoMovedAnim
                LD      H,(IX+pYDraw)
                LD      D,(IX+pHeight)
                LD      A,D
                ADD     A,H
                LD      L,A
                LD      A,C
                CP      H
                JR      NC,UseYNewMin
                LD      H,C
UseYNewMin:     LD      A,B
                CP      L
                JR      C,UseYNewMax
                LD      L,B
UseYNewMax:     LD      A,L
                SUB     H
                LD      L,A

                LD      D,(IX+pXDraw)
                LD      A,(IX+pWidth)
                ADD     A,D
                LD      E,A
                POP     BC
                LD      A,C
                CP      D
                JR      NC,UseXNewMin
                LD      D,C
UseXNewMin:     LD      A,B
                CP      E
                JR      C,UseXNewMax
                LD      E,B
UseXNewMax:     LD      A,E
                SUB     D
                LD      E,A
                CALL    DrawWindow
                RET

NoMovedAnim:    POP     BC
                RET

AnimRat:        LD      A,(IX+pAnPower)
                OR      A
                JP      Z,DeadRat
                CALL    AnimsGravity
                CCF
                SBC     A,A
                LD      (SortFlag),A
                JR      NZ,DoRatMove
                LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                OR      (IX+pZTo)
                CALL    Z,ChangeRatDir
DoRatMove:      LD      A,R
                AND     $7F
                CP      $70
                CALL    NC,ChangeRatDir
                CALL    AnimAllMove
                LD      A,(IX+pSprNo)
                XOR     $01
                LD      (IX+pSprNo),A
                LD      A,(SortFlag)
                OR      A
                RET     Z
                CALL    SortDrawList
                OR      A
                RET

DeadDog:        LD      A,(IX+pSprNo)
                AND     $80
                OR      $5A
                LD      (IX+pSprNo),A
DeadRat:        LD      (IX+pObjType),MoveType
                CALL    ZeroTos
                LD      (IX+pAnimRout+$00),LOW AnimMove
                LD      (IX+pAnimRout+$01),HIGH AnimMove
                OR      A
                RET

DeadBat:        CALL    TakeColl
                CALL    TakeAnim
                CALL    TakeDraw
                OR      A
                RET

ChangeRatDir:   LD      A,R
                AND     $03
                ADD     A,A
                LD      L,A
                ADD     A,A
                ADD     A,L
                ADD     A,LOW RatTable
                LD      L,A
                ADC     A,HIGH RatTable
                SUB     L
                LD      H,A
                CALL    CopyTable
                INC     HL
                LD      A,(HL)
                LD      (IX+pXSize),A
                INC     HL
                LD      A,(HL)
                LD      (IX+pYSize),A
                RET

RatTable:       DEFB    $02,$00,$00,$AA,$06,$02
                DEFB    $00,$02,$00,$2A,$02,$06
                DEFB    $FE,$00,$00,$A8,$06,$02
                DEFB    $00,$FE,$00,$28,$02,$06

AnimBat:        LD      A,(IX+pAnPower)
                OR      A
                JP      Z,DeadBat
                LD      A,(IX+pZTo)
                OR      A
                JR      NZ,FlyOkay
                LD      A,R
                RRA
                SBC     A,A
FlyOkay:        BIT     7,A
                JR      NZ,FlyDown
                LD      (IX+pZTo),$02
                CALL    GetBatSprite
                CALL    AnimAllMove
                LD      A,(IX+pZReal)
                CP      $40
                JR      NC,ChangeToDown
                LD      A,R
                AND     $7F
                CP      $7C
                JR      C,NoChangeDown
ChangeToDown:   LD      (IX+pZTo),$FF
NoChangeDown:   LD      A,(SortFlag)
                OR      A
                RET     Z
                CALL    SortDrawList
                OR      A
                RET

FlyDown:        LD      (IX+pZTo),$FE
                LD      IY,(ManList)
                LD      A,(IY+pXReal)
                SUB     (IX+pXReal)
                LD      C,A
                LD      E,A
                JP      P,PosXRealAnims
                NEG
                LD      E,A
PosXRealAnims:  LD      A,(IY+pYReal)
                SUB     (IX+pYReal)
                LD      B,A
                JP      P,PosYRealAnims
                NEG
PosYRealAnims:  CP      E
                JR      NC,MoveBatY
                LD      A,C
                ADD     A,A
                SBC     A,A
                ADD     A,A
                INC     A
                ADD     A,A
                LD      (IX+pXTo),A
                LD      (IX+pYTo),$00
                JP      BatMoved
MoveBatY:       LD      A,B
                ADD     A,A
                SBC     A,A
                ADD     A,A
                INC     A
                ADD     A,A
                LD      (IX+pYTo),A
                LD      (IX+pXTo),$00
BatMoved:       CALL    GetBatSprite
                CALL    AnimAllMove
                LD      A,(SortFlag)
                OR      A
                RET     Z
                CALL    SortDrawList
                OR      A
                RET

GetBatSprite:   LD      C,$5E
                LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                JP      P,GotSprOne
                LD      C,$5C
GotSprOne:      LD      A,(IX+pXTo)
                OR      A
                JR      Z,GotSprY
                LD      A,C
                OR      $80
                LD      C,A
GotSprY:        LD      A,(IX+pSprNo)
                AND     $01
                XOR     $01
                OR      C
                LD      (IX+pSprNo),A
                RET

AnimSpider:     LD      A,(IX+pAnPower)
                OR      A
                JP      Z,DeadRat
                CALL    AnimsGravity
                CCF
                SBC     A,A
                LD      (SortFlag),A
                JR      NZ,DoSpiderMove
                LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                OR      (IX+pZTo)
                CALL    Z,ChangeSpidDir
DoSpiderMove:   LD      A,R
                AND     $7F
                CP      $70
                CALL    NC,ChangeSpidDir
                CALL    AnimAllMove
                LD      A,(IX+pSprNo)
                XOR     $01
                LD      (IX+pSprNo),A
                LD      A,(SortFlag)
                OR      A
                RET     Z
                CALL    SortDrawList
                OR      A
                RET

ChangeSpidDir:  LD      A,R
                AND     $03
                ADD     A,A
                ADD     A,A
                ADD     A,LOW SpiderTable
                LD      L,A
                ADC     A,HIGH SpiderTable
                SUB     L
                LD      H,A
CopyTable:      LD      A,(HL)
                LD      (IX+pXTo),A
                LD      (IX+pXFrom),A
                INC     HL
                LD      A,(HL)
                LD      (IX+pYTo),A
                LD      (IX+pYFrom),A
                INC     HL
                LD      A,(HL)
                LD      (IX+pZTo),A
                LD      (IX+pZFrom),A
                INC     HL
                LD      A,(HL)
                LD      (IX+pSprNo),A
                RET

SpiderTable:    DEFB    $01,$00,$00,$AE
                DEFB    $00,$01,$00,$2E
                DEFB    $FF,$00,$00,$AC
                DEFB    $00,$FF,$00,$2C

DogsY:          LD      A,(IX+pAnPower)
                OR      A
                JP      Z,DeadDog
                CALL    AnimsGravity
                CCF
                SBC     A,A
                LD      (SortFlag),A
                JR      NZ,DoDogYMove
                LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                OR      (IX+pZTo)
                CALL    Z,ChangeYDogDir
DoDogYMove:     LD      A,R
                AND     $7F
                CP      $78
                CALL    NC,ChangeYDogDir
                JP      DogHack

DogsX:          LD      A,(IX+pAnPower)
                OR      A
                JP      Z,DeadDog
                CALL    AnimsGravity
                CCF
                SBC     A,A
                LD      (SortFlag),A
                JR      NZ,DoDogXMove
                LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                OR      (IX+pZTo)
                CALL    Z,ChangeXDogDir
DoDogXMove:     LD      A,R
                AND     $7F
                CP      $78
                CALL    NC,ChangeXDogDir
DogHack:        CALL    AnimAllMove
                INC     (IX+pSprNo)
                LD      C,(IX+pSprNo)
                LD      A,C
                AND     $0F
                CP      $0A
                JR      Z,LoopDog
                CP      $07
                JR      NZ,NotOverDog
                LD      A,C
                AND     $F0
                OR      $04
                JP      DoSprDog
LoopDog:        LD      A,C
                AND     $F0
                OR      $08
DoSprDog:       LD      (IX+pSprNo),A
NotOverDog:     LD      A,(SortFlag)
                OR      A
                RET     Z
                CALL    SortDrawList
                OR      A
                RET

ChangeYDogDir:  LD      HL,DogYTable
                LD      A,(IX+pSprNo)
                CP      $57
                JR      NC,ChangeDogHack
                LD      HL,DogYTable+004
                JR      ChangeDogHack

ChangeXDogDir:  LD      HL,DogXTable
                LD      A,(IX+pSprNo)
                CP      $D7
                JR      NC,ChangeDogHack
                LD      HL,DogXTable+004
ChangeDogHack:  CALL    CopyTable
                RET

DogXTable:      DEFB    $FF,$00,$00,$D4
                DEFB    $01,$00,$00,$D7

DogYTable:      DEFB    $00,$FF,$00,$54
                DEFB    $00,$01,$00,$57

AnimLadder:     LD      (IX+pXFrom),$00
                LD      (IX+pYFrom),$00
                LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                SCF
                RET     Z
                CALL    AnimXMove
                CALL    AnimYMove
                LD      A,(IX+pXTo)
                LD      (IX+pXFrom),A
                LD      A,(IX+pYTo)
                LD      (IX+pYFrom),A
                CALL    ZeroTos
                LD      A,(SortFlag)
                OR      A
                SCF
                RET     Z
                CALL    SortDrawList
                OR      A
                RET

AnimMove:       CALL    ZeroFroms
                CALL    AnimsGravity
                CCF
                SBC     A,A
                LD      (SortFlag),A
                JR      NZ,DoMove
                LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                OR      (IX+pZTo)
                SCF
                RET     Z
DoMove:         CALL    AnimAllMove
                LD      A,(IX+pXTo)
                LD      (IX+pXFrom),A
                LD      A,(IX+pYTo)
                LD      (IX+pYFrom),A
                LD      A,(IX+pZTo)
                LD      (IX+pZFrom),A
                CALL    ZeroTos
                LD      A,(SortFlag)
                OR      A
                SCF
                RET     Z
                CALL    SortDrawList
                OR      A
                RET

AnimXMove:      LD      A,(IX+pXTo)
                OR      A
                RET     Z
                LD      (IX+pXFrom),A
                LD      C,A
                LD      A,$FF
                LD      (MoveFlag),A
                LD      A,(IX+pXReal)
                PUSH    AF
                ADD     A,C
                LD      (IX+pXReal),A
                PUSH    IX
                PUSH    IX
                POP     DE
                CALL    AnimCollide
                POP     IX
                LD      (IX+pXFrom),$00
                JR      C,AnimXHit
                POP     AF
                LD      A,$FF
                LD      (SortFlag),A
                OR      A
                RET
AnimXHit:       POP     AF
                LD      (IX+pXReal),A
                XOR     A
                LD      (IX+pXTo),A
                LD      (MoveFlag),A
                RET

AnimYMove:      LD      A,(IX+pYTo)
                OR      A
                RET     Z
                LD      (IX+pYFrom),A
                LD      C,A
                LD      A,$FF
                LD      (MoveFlag),A
                LD      A,(IX+pYReal)
                PUSH    AF
                ADD     A,C
                LD      (IX+pYReal),A
                PUSH    IX
                PUSH    IX
                POP     DE
                CALL    AnimCollide
                POP     IX
                LD      (IX+pYFrom),$00
                JR      C,AnimYHit
                POP     AF
                LD      A,$FF
                LD      (SortFlag),A
                OR      A
                RET
AnimYHit:       POP     AF
                LD      (IX+pYReal),A
                XOR     A
                LD      (IX+pYTo),A
                LD      (MoveFlag),A
                RET

AnimAllMove:    CALL    AnimXMove
                CALL    AnimYMove
AnimZMove:      LD      A,(IX+pZTo)
                OR      A
                RET     Z
                LD      (IX+pZFrom),A
                LD      C,A
                LD      A,$FF
                LD      (MoveFlag),A
                LD      A,(IX+pZReal)
                PUSH    AF
                ADD     A,C
                LD      (IX+pZReal),A
                PUSH    IX
                PUSH    IX
                POP     DE
                CALL    AnimCollide
                POP     IX
                LD      (IX+pZFrom),$00
                JR      C,AnimZHit
                POP     AF
                LD      A,$FF
                LD      (SortFlag),A
                OR      A
                RET
AnimZHit:       POP     AF
                LD      (IX+pZReal),A
                XOR     A
                LD      (IX+pZTo),A
                LD      (MoveFlag),A
                RET

AnimsGravity:   CALL    AnimsDoGravity
                RET     C
                CALL    AnimsDoGravity
                OR      A
                RET

AnimsDoGravity: PUSH    IX
                LD      A,(IX+pZReal)
                PUSH    AF
                DEC     A
                LD      (IX+pZReal),A
                DEC     (IX+pZFrom)
                PUSH    IX
                POP     DE
                CALL    FallCollide
                JR      C,AnimsGravityHit
                POP     AF
                POP     IX
                INC     (IX+pZFrom)
                OR      A
                RET

AnimsGravityHit:POP     AF
                POP     IX
                LD      (IX+pZReal),A
                INC     (IX+pZFrom)
                SCF
                RET

