                segment code

ClearWindow:    LD      A,E
                LD      (SModWindX),A
                LD      A,L
                SRL     A
                LD      L,A
                LD      (SModWindY),A
                LD      A,D
                LD      (SModBottLeftX),A
                LD      A,H
                SRL     A
                LD      H,A
                LD      (SModBottLeftY),A
                PUSH    HL
                PUSH    DE
                LD      B,L
                LD      H,$00
                LD      E,L
                LD      D,H
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,DE
                ADD     HL,HL
                ADD     HL,HL
                LD      DE,DummyScreen
                ADD     HL,DE
                LD      (ClrStack),SP
                DI
                LD      SP,HL
                LD      HL,$0000
StackLoop:      PUSH    HL
                PUSH    HL
                PUSH    HL
                PUSH    HL
                PUSH    HL
                PUSH    HL
                PUSH    HL
                PUSH    HL
                PUSH    HL
                PUSH    HL
                DJNZ    StackLoop
                LD      SP,$0000
ClrStack        EQU     $-$02
                EI
                POP     DE
                POP     HL
                PUSH    HL
                PUSH    DE
                CALL    PrintFloor
                LD      HL,(RoomPoint)
                LD      DE,pConnect
                ADD     HL,DE
                LD      A,(HL)
                RRA
                EX      AF,AF'
                POP     DE
                POP     HL
                LD      A,D
                SUB     $40
                LD      D,A
                LD      A,H
                SUB     $20
                LD      H,A
                EX      AF,AF'
                PUSH    AF
                JR      NC,SkipRgtFlr
                LD      A,D
                CP      $A0
                JR      NC,SkipRgtFlr
                PUSH    HL
                PUSH    DE
                CALL    PrintFloor
                POP     DE
                POP     HL
SkipRgtFlr:     LD      A,D
                ADD     A,$80
                LD      D,A
                POP     AF
                RRA
                JR      NC,SkipLeftFlr
                LD      A,D
                CP      $A0
                CALL    C,PrintFloor
SkipLeftFlr:    CALL    PrintEdges
                LD      IX,ClrWalls
                LD      E,(IX+000H)
                LD      D,(IX+001H)
                LD      IY,Offsets
                LD      A,D
                OR      E
                JR      Z,AA873
                LD      HL,LeftWall
                LD      A,$00
                CALL    PrintWall
AA873:          LD      E,(IX+002H)
                LD      D,(IX+003H)
                LD      A,D
                OR      E
                JR      Z,AA885
                LD      HL,RightWall
                LD      A,$80
                CALL    PrintWall
AA885:          LD      E,(IX+004H)
                LD      D,(IX+005H)
                LD      IY,Offsets+$06
                LD      A,D
                OR      E
                JR      Z,AA89B
                LD      HL,LeftWall
                LD      A,$00
                CALL    PrintWall
AA89B:          LD      E,(IX+00AH)
                LD      D,(IX+00BH)
                LD      A,D
                OR      E
                RET     Z
                LD      IY,Offsets+$0C
                LD      HL,RightWall
                LD      A,$80
PrintWall:      LD      (WallPhase),A
                LD      B,$08
PrintWallLoop:  PUSH    BC
                LD      A,(HL)
                ADD     A,(IY+003H)
                LD      C,A
                INC     HL
                LD      A,(HL)
                ADD     A,(IY+004H)
                LD      B,A
                INC     HL
                OR      A
                JR      Z,SkipWallSpr
                LD      A,(DE)
                OR      A
                JR      Z,SkipWallSpr
                PUSH    DE
                OR      $00
WallPhase       EQU     $-$01
                LD      DE,$1808
                CALL    PrintSprite
                POP     DE
SkipWallSpr:    INC     DE
                POP     BC
                DJNZ    PrintWallLoop
                RET

PrintEdges:     LD      A,$FE
                LD      (EdgeSprite),A
                LD      HL,Edges
                CALL    DoEdges
                LD      A,$7E
                LD      (EdgeSprite),A
DoEdges:        LD      B,$08
EdgeLoop:       PUSH    BC
                LD      C,(HL)
                INC     HL
                LD      B,(HL)
                INC     HL
                LD      DE,$0808
                LD      A,$FE
EdgeSprite      EQU     $-$01
                CALL    PrintSprite
                POP     BC
                DJNZ    EdgeLoop
                RET

PrintFloor:     LD      A,D
                AND     $F0
                LD      C,A
                LD      A,E
                ADD     A,D
                DEC     A
                OR      $0F
                INC     A
                SUB     C
                RRA
                RRA
                RRA
                RRA
                AND     $0F
                LD      E,A
                LD      A,H
                AND     $F8
                LD      B,A
                LD      A,L
                LD      L,D
                ADD     A,H
                DEC     A
                OR      $07
                INC     A
                SUB     B
                RRA
                RRA
                RRA
                AND     $1F
                LD      D,A
AA91C:          PUSH    BC
                PUSH    DE
AA91E:          PUSH    DE
                LD      A,C
                CP      $40
                JR      C,AA927
                LD      A,$70
                SUB     C
AA927:          SRA     A
                LD      E,A
                LD      A,B
                CP      $48
                JR      NC,AA94B
                CP      $28
                JR      C,AA936
                LD      A,$48
                SUB     B
AA936:          ADD     A,E
                CP      $20
                JR      C,AA94B
                PUSH    HL
                PUSH    BC
                LD      A,B
                SUB     H
                LD      B,A
                LD      A,C
                SUB     L
                LD      C,A
                LD      A,(FloorChar)
                CALL    FloorSprite
                POP     BC
                POP     HL
AA94B:          LD      A,C
                ADD     A,$10
                LD      C,A
                POP     DE
                DEC     E
                JR      NZ,AA91E
                POP     DE
                POP     BC
                LD      A,B
                ADD     A,$08
                LD      B,A
                DEC     D
                JR      NZ,AA91C
                RET

PrintSprite:    EX      AF,AF'
                LD      A,C
                SUB     $00
SModBottLeftX   EQU     $-$01
                LD      C,A
                LD      A,C
                OR      A
                JP      M,AA96D
                CP      $00
SModWindX       EQU     $-$01
                RET     NC
                JP      AA970

AA96D:          DEC     A
                ADD     A,E
                RET     NC
AA970:          LD      A,B
                SUB     $00
SModBottLeftY   EQU     $-$01
                LD      B,A
                LD      A,B
                OR      A
                JP      M,AA97F
                CP      $00
SModWindY       EQU     $-$01
                RET     NC
                JP      AA982

AA97F:          DEC     A
                ADD     A,D
                RET     NC
AA982:          EX      AF,AF'
                PUSH    HL
                CALL    FloorSprite
                POP     HL
                RET

