                segment code

CollideXYMax    EQU     $41

GetCollParms:   LD      (ScnObjType),A
                LD      IXH,D
                LD      IXL,E
                LD      C,(IX+pXReal)
                LD      B,(IX+pXSize)
                EXX
                LD      C,(IX+pYReal)
                LD      B,(IX+pYSize)
                LD      E,(IX+pZReal)
                LD      D,(IX+pZSize)
                EXX
                RET

FallCollide:    CALL    AnimWall
                RET     C
                LD      A,$FF
                CALL    GetCollParms
                LD      IX,CollList-pLinkColl
                PUSH    DE
NextFallColl:   POP     DE
                CALL    CollideMain
                PUSH    DE
                JP      Z,SeeIfHitFall
                LD      A,(IX+pObjType)
                LD      D,$00
                CP      BlockType
                JR      Z,GotFallObjType
                CP      StairType
                JR      Z,GotFallObjType
                CP      FrameType
                JR      Z,GotFallObjType
                LD      D,$40
GotFallObjType: CALL    GetObjOffset
                JP      C,NextFallColl
                LD      A,D
                LD      (ScnObjType),A
                LD      (ScnObjHit),IX
                JP      NextFallColl

GetObjOffset:   LD      A,C
                SUB     (IX+pXReal)
                JP      NC,FallXPos
                NEG
FallXPos:       ADD     A,D
                LD      D,A
                EXX
                LD      A,C
                SUB     (IX+pXReal)
                JP      NC,FallYPos
                NEG
FallYPos:       EXX
                ADD     A,D
                LD      D,A
                EXX
                LD      A,E
                SUB     (IX+pZReal)
                JP      NC,FallZPos
                NEG
FallZPos:       EXX
                ADD     A,D
                LD      D,A
                LD      A,(ScnObjType)
                CP      D
                RET

SeeIfHitFall:   POP     DE
                LD      A,(ScnObjType)
                CP      $FF
                RET     Z
                LD      IX,(ScnObjHit)
                LD      A,(IX+pObjType)
                CP      BlockType
                SCF
                RET     Z
                CP      PickType
                SCF
                RET     Z
                CP      StairType
                SCF
                RET     Z
                CP      FrameType
                SCF
                RET     Z
OnTopMove:      LD      HL,pXTo
                ADD     HL,DE
                LD      A,(IX+pXFrom)
                ADD     A,(HL)
                JP      Z,FallX
                ADD     A,A
                SBC     A,A
                OR      $01
FallX:          LD      (HL),A
                INC     HL
                LD      A,(IX+pYFrom)
                ADD     A,(HL)
                JP      Z,FallY
                ADD     A,A
                SBC     A,A
                OR      $01
FallY:          LD      (HL),A
                SCF
                RET

AnWallHit:      SCF
                RET

AnimWall:       LD      HL,pXReal
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                JP      M,AnWallHit
                INC     HL
                ADD     A,(HL)
                CP      CollideXYMax
                JP      NC,AnWallHit
                INC     HL
                LD      A,(HL)
                OR      A
                JP      M,AnWallHit
                INC     HL
                ADD     A,(HL)
                CP      CollideXYMax
                JP      NC,AnWallHit
                INC     HL
                LD      A,(HL)
                OR      A
                JP      M,AnWallHit
                OR      A
                RET

AnimCollide:    CALL    AnimWall
                RET     C
                LD      A,$FF
                CALL    GetCollParms
                LD      IX,CollList-pLinkColl
                PUSH    DE
NextAnimColl:   POP     DE
                CALL    CollideMain
                PUSH    DE
                JP      Z,SeeIfHitAnim
                LD      A,(IX+pObjType)
                CP      ManType
                JP      NZ,NotDeathMan
                LD      HL,pObjType
                ADD     HL,DE
                BIT     7,(HL)
                JP      Z,NotDeathMan
                LD      A,(ManList)
                CP      IXL
                JP      NZ,NotDeathMan
                LD      A,(ManList+001)
                CP      IXH
                JP      NZ,NotDeathMan
                LD      IXH,D
                LD      IXL,E
                CALL    DeathRout
                LD      IX,(ManList)
                LD      A,(IX+pObjType)
NotDeathMan:    AND     $3F
                LD      D,$00
                CP      BlockType
                JR      Z,GotAnimObjType
                CP      FrameType
                JR      Z,GotAnimObjType
                LD      D,$20
                CP      StairType
                JR      Z,GotAnimObjType
                LD      D,$40
GotAnimObjType: CALL    GetObjOffset
                JP      C,NextAnimColl
                LD      A,D
                LD      (ScnObjType),A
                LD      (ScnObjHit),IX
                JP      NextAnimColl

SeeIfHitAnim:   POP     DE
                LD      A,(ScnObjType)
                CP      $FF
                RET     Z
                LD      IX,(ScnObjHit)
                LD      A,(IX+pObjType)
                CP      BlockType
                SCF
                RET     Z
                CP      PickType
                SCF
                RET     Z
                LD      HL,pObjType
                ADD     HL,DE
                LD      A,(HL)
                AND     $0F
                CP      ManType AND $0F
                JR      Z,DoSumit
                LD      A,(IX+pObjType)
                CP      FrameType
                SCF
                RET     Z
                CP      StairType
                SCF
                RET     Z
                CP      FrameType
                SCF
                RET     Z
                JP      MoveBlock
DoSumit:        LD      A,(IX+pObjType)
                CP      StairType
                JP      Z,MoveUpStairs
                CP      LadderType
                JP      Z,MoveUpLadder
                CP      FrameType
                JP      Z,MoveByFrame
                JP      MoveBlock

PickCollide:    LD      A,$00
                CALL    GetCollParms
                LD      IX,CollList-pLinkColl
                PUSH    DE
NextPickColl:   POP     DE
                CALL    CollideMain
                PUSH    DE
                JR      Z,SeeIfHitPick
                LD      A,(IX+pObjType)
                BIT     Pick,A
                JR      NZ,GotAPickObj
                LD      A,(ScnObjType)
                OR      (IX+pObjType)
                LD      (ScnObjType),A
                LD      (ScnObjHit),IX
                JP      NextPickColl

GotAPickObj:    POP     DE
                SCF
                RET

SeeIfHitPick:   POP     DE
                LD      A,(ScnObjType)
                OR      A
                JR      NZ,SomethingElse
                CALL    AnimWall
                RET     NC
SomethingElse:  XOR     A
                SCF
                RET

ScnCollide:     LD      A,$FF
                CALL    GetCollParms
                LD      IX,CollList-pLinkColl
                PUSH    DE
NextScnColl:    POP     DE
                CALL    CollideMain
                PUSH    DE
                JR      Z,SeeIfHitScn
                LD      A,(IX+pObjType)
                LD      HL,pHitType
                ADD     HL,DE
                OR      (HL)
                LD      (HL),A
                LD      A,(IX+pObjType)
                BIT     Death,A
                LD      D,$A0                   ;Death
                JR      NZ,GotScnObjType
                AND     $1F
                LD      D,$60                   ;Stairs
                CP      StairType
                JR      Z,GotScnObjType
                CP      LadderType
                JR      Z,GotScnObjType
                LD      D,$40                   ;Frame
                CP      FrameType
                JR      Z,GotScnObjType
                LD      D,$80                   ;Moving blocks
                CP      MoveType
                JR      Z,GotScnObjType
                CP      AltMoveType
                JR      Z,GotScnObjType
                LD      D,$00                   ;Door
                CP      DoorType
                JR      Z,GotScnObjType
                LD      D,$20                   ;Block
GotScnObjType:  CALL    GetObjOffset
                JR      C,NextScnColl
                LD      A,D
                LD      (ScnObjType),A
                LD      (ScnObjHit),IX
                JP      NextScnColl

SeeIfHitScn:    POP     DE
                LD      A,(ScnObjType)
                CP      $FF
                RET     Z
                LD      IX,(ScnObjHit)
                LD      A,(IX+pObjType)
                AND     $3F
                CP      StairType
                JR      Z,MoveUpStairs
                CP      LadderType
                JR      Z,MoveUpLadder
                CP      FrameType
                JR      Z,MoveByFrame
                CP      MoveType
                JR      Z,MoveBlock
                CP      AltMoveType
                JR      Z,MoveBlock
                SCF
                RET

MoveUpLadder:   LD      HL,pXTo
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                JR      Z,NoLadderX
                BIT     7,(IX+pSprNo)
                JR      Z,MoveByFrame
                JP      MoveBlock
NoLadderX:      LD      HL,pYTo
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                JR      Z,MoveBlock
                BIT     7,(IX+pSprNo)
                JR      Z,MoveBlock
                JP      MoveByFrame

MoveUpStairs:   LD      HL,pXTo
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                JR      Z,NotMoveX
                BIT     7,(IX+pSprNo)
                JR      Z,MoveByFrame
                SCF
                RET
NotMoveX:       LD      HL,pYTo
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                SCF
                RET     Z
                BIT     7,(IX+pSprNo)
                SCF
                RET     Z
MoveByFrame:    LD      HL,pXTo
                ADD     HL,DE
                LD      A,(IX+pXFrom)
                ADD     A,(HL)
                LD      (HL),A
                INC     HL
                LD      A,(IX+pYFrom)
                ADD     A,(HL)
                LD      (HL),A
                INC     HL
                LD      A,(IX+pZFrom)
                ADD     A,(HL)
                LD      (HL),A
                SCF
                RET

MoveBlock:      LD      HL,pXFrom
                ADD     HL,DE
                LD      A,(IX+pXTo)
                ADD     A,(HL)
                JR      Z,BlockX
                ADD     A,A
                SBC     A,A
                OR      $01
BlockX:         LD      (IX+pXTo),A
                INC     HL
                LD      A,(IX+pYTo)
                ADD     A,(HL)
                JR      Z,BlockY
                ADD     A,A
                SBC     A,A
                OR      $01
BlockY:         LD      (IX+pYTo),A
                SCF
                RET

                segment data
ScnObjType:     DEFB    $00
ScnObjHit:      DEFW    $0000
                segment code

GravCollide:    LD      A,$FF
                CALL    GetCollParms
                LD      IX,CollList-pLinkColl
                PUSH    DE
NextGravColl:   POP     DE
                CALL    CollideMain
                PUSH    DE
                JR      Z,SeeIfHitGrav
                LD      A,(IX+pObjType)
                LD      D,$60
                BIT     Death,A
                JR      NZ,GotGravObjType
                LD      D,$00
                CP      BlockType
                JR      Z,GotGravObjType
                CP      StairType
                JR      Z,GotGravObjType
                CP      FrameType
                JR      Z,GotGravObjType
                LD      D,$40
GotGravObjType: CALL    GetObjOffset
                JR      C,NextGravColl
                LD      A,D
                LD      (ScnObjType),A
                LD      (ScnObjHit),IX
                JP      NextGravColl

SeeIfHitGrav:   POP     DE
                LD      A,(ScnObjType)
                CP      $FF
                RET     Z
                LD      IX,(ScnObjHit)
                LD      A,(IX+pObjType)
                CP      BlockType
                SCF
                RET     Z
                CP      PickType
                SCF
                RET     Z
                CP      StairType
                SCF
                RET     Z
                CP      FrameType
                SCF
                JP      NZ,OnTopMove
                RET

CollideMain:    EXX
CollMainLoopExx:EXX
CollMainLoop:   LD      L,(IX+pLinkColl+$00)
                LD      H,(IX+pLinkColl+$01)
                LD      A,H
                OR      L
                RET     Z
                PUSH    HL
                SBC     HL,DE
                POP     IX
                JR      Z,CollMainLoop
                LD      A,(IX+pXReal)
                SUB     B
                SUB     C
                JP      P,CollMainLoop
                LD      A,C
                SUB     (IX+pXReal)
                SUB     (IX+pXSize)
                JP      P,CollMainLoop
                EXX
                LD      A,(IX+pYReal)
                SUB     B
                SUB     C
                JP      P,CollMainLoopExx
                LD      A,C
                SUB     (IX+pYReal)
                SUB     (IX+pYSize)
                JP      P,CollMainLoopExx
                LD      A,(IX+pZReal)
                SUB     D
                SUB     E
                JP      P,CollMainLoopExx
                LD      A,E
                SUB     (IX+pZReal)
                SUB     (IX+pZSize)
                JP      P,CollMainLoopExx
                EXX
                SCF
                RET

WallCollide:    LD      IY,(RoomPoint)
                LD      A,(IY+pConnect)
                LD      C,A
                LD      HL,pXReal
                ADD     HL,DE
                LD      A,(HL)
                INC     HL
                ADD     A,(HL)
                CP      CollideXYMax
                JR      C,OkayWall
                LD      HL,pYReal
                ADD     HL,DE
                LD      A,(HL)
                INC     HL
                ADD     A,(HL)
                CP      CollideXYMax
                CCF
                RET     C
OkayWall:       CALL    CheckXWall
                RET     C
                CALL    CheckYWall
                RET     C
                CALL    CheckZWall
                RET

CheckXWall:     LD      HL,pXReal
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                JP      M,XWallOver
                INC     HL
                ADD     A,(HL)
                CP      CollideXYMax
                CCF
                RET     NC
                BIT     1,C
                SCF
                RET     Z
                CCF
                RET
XWallOver:      BIT     3,C
                SCF
                RET     Z
                CCF
                RET

CheckYWall:     LD      HL,pYReal
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                JP      M,YWallOver
                INC     HL
                ADD     A,(HL)
                CP      CollideXYMax
                CCF
                RET     NC
                BIT     0,C
                SCF
                RET     Z
                CCF
                RET
YWallOver:      BIT     2,C
                SCF
                RET     Z
                CCF
                RET

CheckZWall:     LD      HL,pZReal
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                SCF
                RET     M
                OR      A
                RET

