                segment code

DoListXYMax     EQU     $40

SortDrawList:   CALL    RePosition
                CALL    TakeDraw
                CALL    AddDraw
                RET

AddAnim:        LD      HL,(AnimList)
                LD      (IX+pLinkAnim+$00),L
                LD      (IX+pLinkAnim+$01),H
                LD      (AnimList),IX
                RET

TakeAnim:       LD      D,IXH
                LD      E,IXL
                LD      IY,AnimList-pLinkAnim
TakeAnLoop:     LD      L,(IY+pLinkAnim+$00)
                LD      H,(IY+pLinkAnim+$01)
                LD      A,H
                OR      L
                RET     Z
                PUSH    HL
                SBC     HL,DE
                JR      Z,GotAnimTake
                POP     IY
                JP      TakeAnLoop
GotAnimTake:    POP     HL
                LD      HL,pLinkAnim
                ADD     HL,DE
                LD      A,(HL)
                LD      (IY+pLinkAnim+$00),A
                INC     HL
                LD      A,(HL)
                LD      (IY+pLinkAnim+$01),A
                RET

AddColl:        LD      HL,(CollList)
                LD      (IX+pLinkColl+$00),L
                LD      (IX+pLinkColl+$01),H
                LD      (CollList),IX
                RET

TakeColl:       LD      D,IXH
                LD      E,IXL
                LD      IY,CollList-pLinkColl
TakeColLoop:    LD      L,(IY+pLinkColl+$00)
                LD      H,(IY+pLinkColl+$01)
                LD      A,H
                OR      L
                RET     Z
                PUSH    HL
                SBC     HL,DE
                JR      Z,GotCollTake
                POP     IY
                JP      TakeColLoop
GotCollTake:    POP     HL
                LD      HL,pLinkColl
                ADD     HL,DE
                LD      A,(HL)
                LD      (IY+pLinkColl+$00),A
                INC     HL
                LD      A,(HL)
                LD      (IY+pLinkColl+$01),A
                RET

AddDraw:        EXX
                LD      A,(IX+pXReal)
                ADD     A,$04
                LD      C,A
                LD      B,(IX+pXSize)
                LD      A,(IX+pYReal)
                ADD     A,$04
                LD      E,A
                LD      D,(IX+pYSize)
                LD      H,(IX+pZSize)
                LD      A,$50
                SUB     (IX+pZReal)
                SUB     H
                LD      L,A
                EXX
                LD      IY,DrawFour
                LD      A,(IX+pXReal)
                OR      A
                JP      M,GotDrawNum
                LD      A,(IX+pYReal)
                OR      A
                JP      M,GotDrawNum
                CP      (IX+pXReal)
                JR      NC,GotGreater
                LD      A,(IX+pXReal)
                LD      IY,DrawTwo
                CP      DoListXYMax
                JR      NC,GotDrawNum
                JP      NormDraw

GotGreater:     LD      IY,DrawThree
                CP      DoListXYMax
                JR      NC,GotDrawNum
NormDraw:       LD      IY,DrawList
GotDrawNum:     LD      (ListNumber),IY
AddDrawSort:    LD      (TempSortCell),IY
AddIgnore:      LD      L,(IY+pLinkF+$00)
                LD      H,(IY+pLinkF+$01)
                LD      A,L
                OR      H
                JR      Z,AddToDraw
                PUSH    HL
                CALL    PriorCheck
                POP     IY
                JR      NC,AddDrawSort
                OR      A
                JR      NZ,AddIgnore

AddToDraw:      LD      BC,(ListNumber)
                LD      IY,(TempSortCell)
                LD      E,(IY+pLinkF+$00)
                LD      D,(IY+pLinkF+$01)
                PUSH    IX
                POP     HL
                LD      (IY+pLinkF+$00),L
                LD      (IY+pLinkF+$01),H
                LD      (HL),E
                INC     HL
                LD      (HL),D
                LD      A,D
                OR      E
                JR      NZ,AddDNotEnd1
                LD      D,B
                LD      E,C
AddDNotEnd1:    PUSH    DE
                EX      (SP),IY
                POP     DE
                LD      A,E
                CP      C
                JR      NZ,AddDNotEnd2
                LD      A,D
                CP      B
                JR      NZ,AddDNotEnd2
                LD      DE,$0000
AddDNotEnd2:    LD      (IX+pLinkB+$00),E
                LD      (IX+pLinkB+$01),D
                DEC     HL
                LD      (IY+pLinkB+$00),L
                LD      (IY+pLinkB+$01),H
                RET

                segment data
TempSortCell:   DEFW    $0000
ListNumber:     DEFW    $0000
                segment code

PriorCheck:     LD      DE,pXReal
                ADD     HL,DE
                LD      A,(HL)
                ADD     A,004
                LD      C,A
                INC     HL
                LD      B,(HL)
                INC     HL
                LD      A,(HL)
                ADD     A,$04
                LD      E,A
                INC     HL
                LD      D,(HL)
                INC     HL
                LD      A,$50
                SUB     (HL)
                INC     HL
                LD      H,(HL)
                SUB     H
                LD      L,A

                LD      A,$00
                EX      AF,AF'

                LD      A,C
                EXX
                SUB     B
                SUB     C
                EXX
                JP      P,NoHitX
                EXX
                LD      A,C
                EXX
                SUB     B
                SUB     C
                JP      P,NoHitX
                EX      AF,AF'
                OR      $02
                EX      AF,AF'
NoHitX:         LD      A,E
                EXX
                SUB     D
                SUB     E
                EXX
                JP      P,NoHitY
                EXX
                LD      A,E
                EXX
                SUB     D
                SUB     E
                JP      P,NoHitY
                EX      AF,AF'
                OR      $04
                EX      AF,AF'
NoHitY:         LD      A,L
                EXX
                SUB     L
                SUB     H
                EXX
                JP      P,NoHitZ
                EXX
                LD      A,L
                EXX
                SUB     L
                SUB     H
                JP      P,NoHitZ
                EX      AF,AF'
                OR      $08
                EX      AF,AF'
NoHitZ:         EX      AF,AF'
                PUSH    HL
                ADD     A,LOW PriorTable
                LD      L,A
                ADC     A,HIGH PriorTable
                SUB     L
                LD      H,A
                LD      A,(HL)
                INC     HL
                LD      H,(HL)
                LD      L,A
                EX      (SP),HL
                RET

PriorTable:     DEFW    NoOverlap,OnlyX,OnlyY,OnlyXAndY
                DEFW    OnlyZ,OnlyXAndZ,OnlyYAndZ,NoOverlap

NoOverlap:      LD      A,E
                ADD     A,C
                ADD     A,L
                LD      L,A
                ADC     A,$00
                SUB     L
                LD      H,A
                EXX
                LD      A,E
                ADD     A,C
                ADD     A,L
                EXX
                LD      E,A
                ADC     A,$00
                SUB     E
                LD      D,A
                SBC     HL,DE
                LD      A,$FF
                RET

OnlyX:          EXX
                LD      A,E
                ADD     A,L
                EXX
                LD      C,A
                LD      A,E
                ADD     A,L
                SUB     C
                LD      A,$FF
                RET

OnlyY:          EXX
                LD      A,C
                ADD     A,L
                EXX
                LD      E,A
                LD      A,C
                ADD     A,L
                SUB     E
                LD      A,$FF
                RET

OnlyZ:          EXX
                LD      A,C
                ADD     A,E
                EXX
                LD      L,A
                LD      A,C
                ADD     A,E
                SUB     L
                LD      A,$FF
                RET

OnlyXAndY:      LD      A,L
                EXX
                SUB     L
                EXX
                LD      A,$00
                RET

OnlyYAndZ:      LD      A,C
                EXX
                SUB     C
                EXX
                LD      A,$00
                RET

OnlyXAndZ:      LD      A,E
                EXX
                SUB     E
                EXX
                LD      A,$00
                RET

TakeDraw:       LD      E,(IX+pLinkF+$00)
                LD      D,(IX+pLinkF+$01)
                LD      L,(IX+pLinkB+$00)
                LD      H,(IX+pLinkB+$01)
                PUSH    HL
                LD      A,H
                OR      L
                JR      NZ,TakeDNotEnd1
                LD      HL,DrawList
TakeDNotEnd1:   LD      (HL),E
                INC     HL
                LD      (HL),D
                POP     HL
                EX      DE,HL
                LD      A,H
                OR      L
                JR      NZ,TakeDNotEnd2
                LD      HL,DrawList
TakeDNotEnd2:   INC     HL
                INC     HL
                LD      (HL),E
                INC     HL
                LD      (HL),D
                RET

RePosition:     LD      E,(IX+pXReal)
                LD      L,(IX+pYReal)
                LD      A,L
                ADD     A,A
                SBC     A,A             ;Y Real
                LD      H,A
                LD      A,E
                ADD     A,A
                SBC     A,A             ;X Real
                LD      D,A
                PUSH    HL
                OR      A
                SBC     HL,DE
                LD      BC,Offset
                ADD     HL,BC
                LD      C,(IX+pSprNo)
                LD      B,$01+HIGH SprSet
                SET     7,C
                LD      A,(BC)
                AND     $7F
                LD      C,A
                LD      A,(IX+pXSize)
                SRA     A
                LD      B,A
                LD      A,(IX+pYSize)
                SRA     A
                SUB     B
                SUB     C
                LD      C,A
                ADD     A,A
                SBC     A,A
                LD      B,A
                ADD     HL,BC
                LD      (IX+pXDraw),L
                LD      BC,$0010
                ADD     HL,BC
                LD      A,H
                OR      A
                JR      Z,XDrawIsOkay
                LD      (IX+pXDraw),$A1
XDrawIsOkay:    POP     HL
                ADD     HL,DE           ;X+Y Real
                LD      C,(IX+pZReal)
                LD      A,C
                ADD     A,A
                LD      C,A
                SBC     A,A             ;Z Real
                LD      B,A
                ADD     HL,BC
                LD      DE,$0010                ;00020
                ADD     HL,DE
                LD      E,(IX+pSprNo)
                RES     7,E
                LD      D,$01+HIGH SprSet
                LD      A,(DE)
                LD      (IX+pHeight),A
                SET     7,E
                LD      A,(DE)
                ADD     A,A
                LD      (IX+pWidth),A
                INC     D
                RES     7,E
                LD      A,(DE)
                LD      E,A
                LD      D,000
                ADD     HL,DE
                LD      (IX+pYDraw),L
                LD      DE,$0037
                ADD     HL,DE
                LD      A,H
                OR      A
                RET     Z
                LD      (IX+pYDraw),$C9
                RET

