                segment code

ScreenHeight    EQU     $C0
ScreenWidth     EQU     $80

DrawScreen:     DI
                LD      H,$90
                LD      L,$30
OuterLoop:      LD      D,$70
                LD      E,$10
InnerLoopDraw:  PUSH    HL
                PUSH    DE
                CALL    NoTopClipDraw
                POP     DE
                POP     HL
                LD      A,D
                SUB     E
                LD      D,A
                JR      NC,InnerLoopDraw
                LD      A,H
                SUB     L
                LD      H,A
                JR      NC,OuterLoop
                LD      HL,$0000
                LD      (LastMoon),HL
                CALL    MoonSun
PrintName:      CALL    Print
                DEFB    $04,$41
                DEFB    $03,$15,$17
                DEFB    $FF
                LD      HL,(ManList)
                LD      DE,pName
                ADD     HL,DE
                CALL    HLPrint
                CALL    DrawPower
                CALL    DrawPick
                CALL    DrawWeap
                EI
                RET

DrawPower:      LD      HL,$280C
                LD      (SizeWindX+$00),HL
                LD      HL,$0028
                LD      DE,$000C
                CALL    ClearWindow
                LD      C,$00
                LD      IX,(ManList)
                LD      A,(IX+pPower)
                SRL     A
                SRL     A
                NEG
                LD      B,A
                LD      A,CoffinSprite
                CALL    MaskSprite
                LD      BC,$B774
                CALL    OutWindow
                RET

MoonSun:        LD      A,(Seconds)
                RRA
                RRA
                AND     $1E
                ADD     A,LOW MoonTable
                LD      L,A
                ADC     A,HIGH MoonTable
                SUB     L
                LD      H,A
                LD      C,(HL)
                INC     HL
                LD      B,(HL)
                LD      HL,(LastMoon)
                OR      A
                SBC     HL,BC
                RET     Z
                LD      (LastMoon),BC
                PUSH    BC
                LD      HL,$180C
                LD      (SizeWindX+$00),HL
                LD      HL,$0018
                LD      DE,$000C
                CALL    ClearWindow
                POP     BC
                LD      A,MoonSprite
                CALL    MaskSprite
                LD      BC,$0000
                LD      A,WindowSprite
                CALL    MaskSprite
                LD      BC,$B768
                CALL    OutWindow
                LD      A,(RoomColour)
                CALL    SetUpULA
                RET

                segment data
LastMoon:       DEFW    $0000
                segment code

MoonTable:      DEFB    $00,$02
                DEFB    $00,$04
                DEFB    $00,$06
                DEFB    $00,$08
                DEFB    $02,$09
                DEFB    $02,$0A
                DEFB    $02,$0B
                DEFB    $04,$0C
                DEFB    $04,$0C
                DEFB    $04,$0C
                DEFB    $06,$0B
                DEFB    $06,$0A
                DEFB    $06,$09
                DEFB    $08,$08
                DEFB    $08,$06
                DEFB    $08,$04

DrawPick:       PUSH    IX
                LD      HL,$180C
                LD      (SizeWindX+$00),HL
                LD      HL,$0018
                LD      DE,$000C
                CALL    ClearWindow
                LD      IX,(ManList)
                LD      A,(IX+pPickSprite)
                OR      A
                LD      BC,$0000
                JR      Z,NoPick
                CALL    MaskSprite
                LD      A,(IX+pPickSprite)
                AND     $7F
                CALL    NamePrint
                PUSH    HL
                CALL    Print
                DEFB    $04,$42
                DEFB    $03,$03,$17
                DEFB    $08,$09
                DEFB    $03,$03,$17
                DEFB    $FF
                POP     HL
                CALL    HLPrint
                LD      BC,$BF00
                CALL    OutWindow
                POP     IX
                RET

NoPick:         CALL    Print
                DEFB    $04,$43
                DEFB    $03,$03,$17
                DEFB    $08,$09
                DEFB    $03,$03,$17
                DEFB    $FF
                LD      BC,$BF00
                CALL    OutWindow
                POP     IX
                RET

DrawWeap:       PUSH    IX
                LD      HL,$180C
                LD      (SizeWindX+$00),HL
                LD      HL,$0018
                LD      DE,$000C
                CALL    ClearWindow
                LD      IX,(ManList)
                LD      A,(IX+pWeapSprite)
                OR      A
                LD      BC,$0000
                JR      Z,NoWeapon
                CALL    MaskSprite
                LD      A,(IX+pWeapSprite)
                CALL    NamePrint
                PUSH    HL
                CALL    Print
                DEFB    $04,$45
                DEFB    $03,$03,$14
                DEFB    $08,$05
                DEFB    $03,$03,$14
                DEFB    $FF
                POP     HL
                CALL    HLPrint
                LD      BC,$A700
                CALL    OutWindow
                POP     IX
                RET

NoWeapon:       CALL    Print
                DEFB    $04,$43
                DEFB    $03,$03,$14
                DEFB    $08,$05
                DEFB    $03,$03,$14
                DEFB    $FF
                LD      BC,$A700
                CALL    OutWindow
                POP     IX
                RET

NamePrint:      LD      HL,NameTable
NamePrtLoop:    LD      C,(HL)
                INC     HL
                CP      C
                RET     Z
                INC     C
                RET     Z
                PUSH    AF
SkipPrtLp:      LD      A,(HL)
                INC     A
                INC     HL
                JR      NZ,SkipPrtLp
                POP     AF
                JP      NamePrtLoop

NameTable:      DEFB    KeySpr1
                DEFB    "Key",$FF
                DEFB    LitLamp
                DEFB    "Lit Lamp",$FF
                DEFB    StakeSprite
                DEFB    "Stake",$FF
                DEFB    GunSprite
                DEFB    "Gun",$FF
                DEFB    SwordSprite
                DEFB    "Sword",$FF
                DEFB    LampSprite
                DEFB    "Lamp",$FF
                DEFB    AxeSprite
                DEFB    "Axe",$FF
                DEFB    DeedSprite
                DEFB    "Deeds",$FF
                DEFB    BootSprite
                DEFB    "Boots",$FF
                DEFB    MatchSprite
                DEFB    "Matches",$FF
                DEFB    GarlicSprite
                DEFB    "Garlic",$FF
                DEFB    ChairSprite
                DEFB    "Chair",$FF
                DEFB    ChairSprite-$01
                DEFB    "Chair",$FF
                DEFB    CandelSprite
                DEFB    "Candles",$FF
                DEFB    CrucifixSprite
                DEFB    "Crucifix",$FF
                DEFB    $FF

DrawWindow:     LD      A,E
                ADD     A,D
                DEC     A
                OR      $03
                INC     A
                LD      C,A
                LD      A,D
                AND     $FC
                LD      D,A                     ;D=Bott Left X
                LD      A,C
                SUB     D
                LD      E,A                     ;E=Size Wind X

                LD      A,H
                ADD     A,L
                DEC     A
                OR      $01
                INC     A
                LD      C,A
                LD      A,H
                AND     $FE
                LD      H,A                     ;H=Scn Y Position
                LD      A,C                     ;L=Scn Y Size
                SUB     H                       ;D=Scn X Position
                JR      NC,WindOkay
                LD      A,$F8
                SUB     H
WindOkay:       LD      L,A                     ;E=Scn X Size
                LD      A,D
                CP      ScreenWidth
                JR      C,NoLeftClipDraw
                ADD     A,E
                RET     Z
                RET     NC
                LD      E,A
                XOR     A
                LD      D,A
NoLeftClipDraw: ADD     A,E
                SUB     ScreenWidth
                JR      C,NoRightClipDraw
                JR      Z,NoRightClipDraw
                NEG
                ADD     A,E
                RET     Z
                RET     NC
                LD      E,A
NoRightClipDraw:LD      A,H
                CP      ScreenHeight
                JR      C,NoBottClipDraw
                ADD     A,L
                RET     Z
                RET     NC
                LD      L,A
                XOR     A
                LD      H,A
NoBottClipDraw: ADD     A,L
                SUB     ScreenHeight
                JR      C,NoTopClipDraw
                JR      Z,NoTopClipDraw
                NEG
                ADD     A,L
                RET     Z
                RET     NC
                LD      L,A
NoTopClipDraw:  LD      A,D
                LD      (WindBottLeft+$00),A
                LD      (SModBottLeftXDraw),A
                LD      A,H
                LD      (WindBottLeft+$01),A
                LD      (SModBottLeftYDraw),A
                LD      A,E
                LD      (SizeWindX),A
                LD      (SModWindXDraw),A
                LD      A,L
                LD      (SizeWindY),A
                LD      (SModWindYDraw),A
                CALL    ClearWindow
                LD      A,(WindBottLeft+$00)
                CP      ScreenWidth/2
                LD      DE,(DrawTwo)
                CALL    C,DrawWindLoop
                LD      A,(WindBottLeft+$00)
                LD      D,A
                LD      A,(SizeWindX)
                ADD     A,D
                CP      ScreenWidth/2
                LD      DE,(DrawThree)
                CALL    NC,DrawWindLoop
                LD      DE,(DrawList)
                CALL    DrawWindLoop
                LD      DE,(DrawFour)
                CALL    DrawWindLoop
                LD      HL,WindBottLeft
                LD      A,(HL)
                LD      C,A
                INC     HL
                LD      A,ScreenHeight-$01
                SUB     (HL)
                LD      B,A
                CALL    OutWindow
                RET

SkipWindObj:    EX      DE,HL
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
DrawWindLoop:   LD      A,D
                OR      E
                RET     Z
                LD      HL,pXDraw
                ADD     HL,DE
                LD      A,(HL)
                SUB     $00
SModBottLeftXDraw EQU     $-$01
                LD      C,A
                JP      M,CheckXOnOver
                CP      $00
SModWindXDraw   EQU     $-$01
                JR      NC,SkipWindObj
                INC     HL
                JP      NoSkipX
CheckXOnOver:   INC     HL
                DEC     A
                ADD     A,(HL)
                JR      NC,SkipWindObj
NoSkipX:        INC     HL
                LD      A,(HL)
                SUB     $00
SModBottLeftYDraw   EQU     $-$01
                LD      B,A
                JP      M,CheckYOnOver
                CP      $00
SModWindYDraw   EQU     $-$01
                JR      NC,SkipWindObj
                JP      NoSkipY
CheckYOnOver:   INC     HL
                DEC     A
                ADD     A,(HL)
                JR      NC,SkipWindObj
NoSkipY:        LD      HL,pSprNo
                ADD     HL,DE
                LD      A,(HL)
                PUSH    DE
                CALL    MaskSprite
                POP     DE
                JP      SkipWindObj

                segment data

WindBottLeft:   DEFW    $0000
SizeWindX:      DEFB    $00
SizeWindY:      DEFB    $00

                segment code

