                segment code

pXOff           EQU     $00
pYOff           EQU     $01
pZOff           EQU     $02
pXDrawOff       EQU     $03
pYDrawOff       EQU     $04
pNearNumber     EQU     $05

XYMin           EQU     $10
XYMax           EQU     $30

Escaped:        LD      A,$02
                JP      EndGame

NewRoom:        PUSH    IX
                PUSH    DE
                LD      HL,$B46A
                OR      A
                SBC     HL,DE
                JP      Z,Escaped
                LD      A,$00
                CALL    SetUpULA
                CALL    CompactOld
                CALL    MenCompactOld
                POP     DE
                CALL    RoomMain
                CALL    DrawScreen
                LD      A,(RoomColour)
                CALL    SetUpULA
                POP     IX
                RET

MenCompactOld:  LD      IX,CollList-pLinkColl
CompMenLoop:    LD      E,(IX+pLinkColl+$00)
                LD      D,(IX+pLinkColl+$01)
                LD      A,D
                OR      E
                RET     Z
                LD      IXH,D
                LD      IXL,E
                LD      A,(IX+pObjType)
                AND     $7F
                CP      ManType AND $7F
                JR      NZ,CompMenLoop
                LD      HL,(NearRoomThree)
                LD      A,(IX+pYReal)
                OR      A
                JP      M,DoCompMan
                LD      HL,(NearRoomOne)
                CP      $40
                JR      NC,DoCompMan
                LD      HL,(NearRoomFour)
                LD      A,(IX+pXReal)
                OR      A
                JP      M,DoCompMan
                CP      $40
                JR      C,CompMenLoop
                LD      HL,(NearRoomTwo)
DoCompMan:      LD      A,(RoomNumber+$01)
                LD      E,A
                INC     HL
                LD      A,(HL)
                SUB     E
                LD      E,A
                LD      A,(IX+pZReal)
                SUB     E
                LD      (IX+pZReal),A
                JP      CompMenLoop

CompactOld:     LD      IX,CollList-pLinkColl
                LD      DE,(RoomNumber)
                LD      A,D
                OR      E
                RET     Z
                LD      HL,(Objects)
CompactOuter:   CALL    NextFreeObj
                RET     C
                EXX
CompactLoop:    LD      E,(IX+pLinkColl+$00)
                LD      D,(IX+pLinkColl+$01)
                LD      A,E
                OR      D
                RET     Z
                LD      IXH,D
                LD      IXL,E
                LD      A,(IX+pObjType)
                AND     $7F
                CALL    CheckCompact
                JR      NZ,CompactLoop
                LD      A,(IX+pObjType)
                AND     $80
                OR      C
                EXX
                EX      AF,AF'
                LD      (HL),E
                INC     HL
                LD      (HL),D
                INC     HL
                LD      A,(IX+pXReal)
                LD      (HL),A
                INC     HL
                LD      A,(IX+pYReal)
                LD      (HL),A
                INC     HL
                LD      A,(IX+pZReal)
                OR      $80
                LD      (HL),A
                INC     HL
                LD      A,(IX+pSprNo)
                LD      (HL),A
                INC     HL
                EX      AF,AF'
                LD      (HL),A
                INC     HL
                LD      A,(IX+pAnPower)
                LD      (HL),A
                INC     HL
                JP      CompactOuter

NextFreeObj:    LD      C,(HL)
                INC     HL
                LD      B,(HL)
                DEC     HL
                LD      A,B
                OR      C
                RET     Z
                LD      A,B
                AND     C
                INC     A
                SCF
                RET     Z
                LD      BC,$0008
                ADD     HL,BC
                JP      NextFreeObj

CheckCompact:   LD      C,$01
                CP      MoveType
                RET     Z
                LD      C,$08
                CP      RatType
                RET     Z
                LD      C,$09
                CP      DogType
                RET     Z
                LD      C,$0E
                CP      DogYType
                RET     Z
                LD      C,$0A
                CP      PickType
                RET     Z
                LD      C,$0C
                CP      SpiderType
                RET     Z
                LD      C,$0F
                CP      WisType
                RET     Z
                RET

GetZedOffs:     LD      A,(RoomNumber+$01)
                LD      C,A
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                LD      A,D
                OR      E
                LD      (DrawIt),A
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                EX      DE,HL
                INC     HL
                LD      A,(HL)
                DEC     HL
                SUB     C
                RET

RoomMain:       CALL    GetRoomPnt
                LD      (RoomNumber),DE
                LD      (RoomPoint),HL
                LD      DE,pConnect
                ADD     HL,DE
                LD      C,(HL)
                LD      HL,RoomOne
                LD      IY,RoomOffsets
                LD      A,$04
GetNrPntsLp:    EX      AF,AF'

                PUSH    HL
                LD      DE,(RoomNumber)
                LD      L,(IY+$00)
                LD      A,E
                ADD     A,L
                AND     $0F
                LD      H,A
                LD      A,E
                AND     $F0
                ADD     A,L
                AND     $F0
                OR      H
                LD      E,A
                CALL    GetRoomPnt
                EX      (SP),HL
                RR      C
                JR      C,IsAWall
                LD      DE,$0000
IsAWall:        LD      (HL),E
                INC     HL
                LD      (HL),D
                INC     HL
                POP     DE
                LD      (HL),E
                INC     HL
                LD      (HL),D
                INC     HL
                INC     IY
                EX      AF,AF'
                DEC     A
                JR      NZ,GetNrPntsLp
                LD      HL,DrawList
                LD      A,$00
                LD      B,$14
ClrLists:       LD      (HL),A
                INC     HL
                DJNZ    ClrLists
                LD      IX,(FreeSpace)
                LD      HL,(RoomPoint)
                LD      IY,Offsets
                LD      (IY+pZOff),$00
                CALL    ExpandMasks
                LD      HL,RoomOne
                CALL    GetZedOffs
                LD      IY,Offsets+$06
                LD      (IY+pZOff),A
                CALL    ExpandMasks
                LD      HL,RoomTwo
                CALL    GetZedOffs
                LD      IY,Offsets+$0C
                LD      (IY+pZOff),A
                CALL    ExpandMasks
                LD      HL,RoomThree
                CALL    GetZedOffs
                LD      IY,Offsets+$12
                LD      (IY+pZOff),A
                CALL    ExpandMasks
                LD      HL,RoomFour
                CALL    GetZedOffs
                LD      IY,Offsets+$18
                LD      (IY+pZOff),A
                CALL    ExpandMasks

                LD      HL,(RoomPoint)
                LD      DE,pColour
                ADD     HL,DE
                LD      A,(HL)
                RRCA
                RRCA
                RRCA
                RRCA
                AND     $0F
                LD      (RoomColour),A
                LD      A,(HL)
                AND     $0F
                ADD     A,$7B
                LD      (FloorChar),A
                INC     IX
                LD      (ObjFree),IX
                LD      IX,ClrWalls
                LD      HL,(RoomPoint)
                LD      IY,Offsets
                CALL    WallExpand
                LD      DE,(RoomOne)
                LD      HL,(NearRoomOne)
                LD      IY,Offsets+$06
                CALL    NrWallExpand
                LD      DE,(RoomTwo)
                LD      HL,(NearRoomTwo)
                LD      IY,Offsets+$0C
                CALL    NrWallExpand
                LD      HL,SprSet+$007F
                LD      E,(HL)
                SET     7,L
                LD      D,(HL)
                LD      (RotFree),DE
                RET

                segment data
ObjFree:        DEFW    $0000
                segment code

GetRoomPnt:     PUSH    BC
                LD      BC,RoomSize+$01
                LD      HL,RoomData+$01
NextRoom:       LD      A,D
                SUB     (HL)
                ADD     A,$40
                CP      $80
                JR      NC,NotRoom
                DEC     HL
                LD      A,(HL)
                CP      E
                JR      Z,GotRoom
                INC     HL
                OR      (HL)
                DEC     HL
                JR      Z,DuffRoom
                ADD     HL,BC
                JP      NextRoom
DuffRoom:       LD      HL,$0000
                POP     BC
                RET
NotRoom:        LD      A,(HL)
                DEC     HL
                OR      (HL)
                JR      Z,DuffRoom
                ADD     HL,BC
                JP      NextRoom
GotRoom:        LD      E,(HL)
                INC     HL
                LD      D,(HL)
                DEC     HL
                POP     BC
                RET

NrWallExpand:   LD      A,H
                OR      L
                JR      Z,DeadExpand
                LD      A,E
                OR      D
                JR      NZ,WallExpand
DeadExpand:     LD      (IX+$00),$00
                LD      (IX+$01),$00
                LD      (IX+$02),$00
                LD      (IX+$03),$00
                LD      DE,$0004
                ADD     IX,DE
                RET
WallExpand:     EX      DE,HL
                LD      HL,pConnect
                LD      BC,$0000
                ADD     HL,DE
                BIT     1,(HL)
                CALL    Z,GetWallPnt1
                LD      (IX+$00),C
                LD      (IX+$01),B
                LD      BC,$0000
                BIT     0,(HL)
                CALL    Z,GetWallPnt2
                LD      (IX+$02),C
                LD      (IX+$03),B
                LD      DE,$0004
                ADD     IX,DE
                RET

GetWallPnt2:    PUSH    HL
                LD      HL,pWall
                ADD     HL,DE
                LD      A,(HL)
                RRA
                RRA
                AND     $3C
                LD      C,A
                DEC     HL
                LD      A,(HL)
                AND     $C0
                OR      C
                JR      WallSkipOv

GetWallPnt1:    PUSH    HL
                LD      HL,pWall
                ADD     HL,DE
                LD      A,(HL)
                AND     $0F
                LD      C,A
                DEC     HL
                LD      A,(HL)
                AND     $30
                OR      C
                ADD     A,A
                ADD     A,A
WallSkipOv:     LD      L,A
                LD      H,$00
                ADD     HL,HL
                LD      BC,Walls
                ADD     HL,BC
                LD      C,L
                LD      B,H
                POP     HL
                RET

AddObjects:     LD      HL,(Objects)
AddObjLoop:     LD      C,(HL)
                INC     HL
                LD      B,(HL)
                LD      A,B
                AND     C
                INC     A
                RET     Z
                PUSH    HL
                PUSH    DE
                LD      A,E
                SUB     C
                LD      C,A
                LD      A,D
                SBC     A,B
                OR      C
                JR      NZ,NotInObject
                LD      A,(IY+pNearNumber)
                OR      A
                JR      NZ,DontKill
                LD      (HL),$00
                DEC     HL
                LD      (HL),$00
                INC     HL
DontKill:       INC     HL
                LD      B,(HL)
                INC     HL
                LD      C,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                LD      A,(HL)
                INC     HL
                CALL    AddScene
NotInObject:    POP     DE
                POP     HL
                LD      BC,$0007
                ADD     HL,BC
                JP      AddObjLoop

AddMan:         LD      L,(IX+pManRoom+$00)
                LD      H,(IX+pManRoom+$01)
                OR      A
                SBC     HL,DE
                RET     NZ
                CALL    GetSize
                LD      A,(IY+pNearNumber)
                OR      A
                JP      Z,AddManZero
                CP      $03
                JP      C,AddManSec
                JR      Z,AddManThree
                LD      A,(IX+pXReal)
                AND     $3F
                ADD     A,(IX+pXSize)
                CP      XYMax
                RET     C
ZedOffRout:     LD      A,(IX+pXReal)
                AND     $3F
                ADD     A,(IY+pXOff)
                LD      (IX+pXReal),A
                LD      A,(IX+pYReal)
                AND     $3F
                ADD     A,(IY+pYOff)
                LD      (IX+pYReal),A
                LD      A,(IX+pZReal)
                AND     $3F
                ADD     A,(IY+pZOff)
                LD      (IX+pZReal),A
                CALL    AddColl
                RET

AddManThree:    LD      A,(IX+pYReal)
                AND     $3F
                ADD     A,(IX+pYSize)
                CP      XYMax
                JR      NC,ZedOffRout
                RET

AddManSec:      LD      A,(IX+pYReal)
                AND     $3F
                CP      XYMin+$01
                JR      C,PutSecMan
                LD      A,(IX+pXReal)
                AND     $3F
                CP      XYMin+$01
PutSecMan:      CALL    ZedOffRout
                CALL    NewStatic
                CALL    RePosition
                LD      A,(IX+pXDraw)
                CP      $A1
                RET     Z
                LD      A,(IX+pYDraw)
                CP      $C9
                RET     Z
                LD      A,(DrawIt)
                OR      A
                CALL    NZ,AddDraw
                RET

AddManZero:     LD      A,(IX+pXReal)
                AND     $3F
                LD      (IX+pXReal),A
                LD      A,(IX+pYReal)
                AND     $3F
                LD      (IX+pYReal),A
                LD      A,(IX+pZReal)
                AND     $3F
                LD      (IX+pZReal),A
                CALL    NewStatic
                CALL    RePosition
                CALL    AddColl
                CALL    AddDraw
                PUSH    IX
                POP     HL
                LD      DE,(ManList)
                OR      A
                SBC     HL,DE
                RET     Z
                LD      (IX+pAnimRout+$00),LOW ManAnim
                LD      (IX+pAnimRout+$01),HIGH ManAnim
                CALL    ZeroFroms
                CALL    ZeroTos
                CALL    AddAnim
                RET

ExpandMasks:    LD      A,H
                OR      L
                RET     Z
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                PUSH    HL

                PUSH    IX

                LD      IX,JohnList
                PUSH    DE
                PUSH    IY
                CALL    AddMan
                POP     IY
                POP     DE

                LD      IX,NosyList
                PUSH    DE
                PUSH    IY
                CALL    AddMan
                POP     IY
                POP     DE

                LD      A,(GameType)
                OR      A
                JR      Z,PartOne

                LD      IX,LucyList
                PUSH    DE
                PUSH    IY
                CALL    AddMan
                POP     IY
                POP     DE

                LD      IX,VanList
                PUSH    DE
                PUSH    IY
                CALL    AddMan
                POP     IY
                POP     DE

PartOne:        POP     IX
                CALL    AddObjects
                POP     HL
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                PUSH    HL
                EX      DE,HL
                CALL    ExpandScenes
                POP     HL
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                EX      DE,HL
                CALL    ExpandComps
                RET

ExpandScenes:   LD      A,(HL)
                CP      EndChar
                RET     Z
                LD      B,A
                INC     HL
                LD      C,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                LD      A,(HL)
                INC     HL
                CALL    AddScene
                JP      ExpandScenes

ExpandComps:    LD      A,(HL)
                CP      EndChar
                RET     Z
                LD      B,(HL)
                INC     HL
                LD      C,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                LD      A,(HL)
                INC     HL
                PUSH    HL
                PUSH    DE
                ADD     A,A
                LD      E,A
                LD      D,$00
                LD      HL,(CompPoints)
                ADD     HL,DE
                LD      A,(HL)
                INC     HL
                LD      H,(HL)
                LD      L,A
                POP     DE
                CALL    CompExpand
                POP     HL
                JP      ExpandComps

CompExpand:     LD      A,(HL)
                CP      EndChar
                RET     Z
                PUSH    BC
                PUSH    DE
                ADD     A,B
                LD      B,A
                INC     HL
                LD      A,(HL)
                ADD     A,C
                LD      C,A
                INC     HL
                LD      A,(HL)
                ADD     A,D
                LD      D,A
                INC     HL
                LD      A,(HL)
                INC     HL
                CALL    AddScene
                POP     DE
                POP     BC
                JP      CompExpand

AddScene:       BIT     7,D
                CALL    NZ,AddScAnim
                LD      E,A
                AND     $7F
                CP      IgnoreSprite
                RET     NC
                PUSH    HL
                PUSH    IY
                LD      (IX+pSprNo),E
                LD      A,(IY+pNearNumber)
                OR      A
                JP      Z,AddMainRoom
                LD      A,(IY+pNearNumber)
                CP      $03
                JP      C,AddSecRoom
                JP      Z,AddRoomThree
                LD      A,(IX+pSprNo)
                AND     $7F
                CP      $64
                JP      NC,NoAddRoom
                PUSH    BC
                PUSH    DE
                CALL    GetSize
                POP     DE
                POP     BC
                LD      A,B
                ADD     A,(IX+pXSize)
                CP      XYMax
                JP      C,NoAddRoom
                CALL    ObjPosRout
                CALL    AddColl
                JP      DoneAddRoom

ObjPosRout:     LD      A,(IY+pXOff)
                ADD     A,B
                LD      (IX+pXReal),A
                LD      A,C
                ADD     A,(IY+pYOff)
                LD      (IX+pYReal),A
                LD      A,D
                ADD     A,(IY+pZOff)
                LD      (IX+pZReal),A
                LD      (IX+pObjType),BlockType
                RET

AddRoomThree:   LD      A,(IX+pSprNo)
                AND     $7F
                CP      $64
                JP      NC,NoAddRoom
                PUSH    BC
                PUSH    DE
                CALL    GetSize
                POP     DE
                POP     BC
                LD      A,C
                ADD     A,(IX+pYSize)
                CP      XYMax
                JP      C,NoAddRoom
                CALL    ObjPosRout
                CALL    AddColl
                JP      DoneAddRoom

AddSecRoom:     PUSH    BC
                PUSH    DE
                CALL    GetSize
                POP     DE
                POP     BC
                LD      A,C
                CP      XYMin+001
                JR      C,PutSecColl
                LD      A,B
                CP      XYMin+$01
PutSecColl:     PUSH    AF
                CALL    ObjPosRout
                POP     AF
                JR      NC,NoAddSecColl
                LD      A,(IX+pSprNo)
                AND     $7F
                CP      $64
                CALL    C,AddColl
                CALL    RePosition
                LD      A,(IX+pXDraw)
                CP      $A1
                JR      Z,DoneAddRoom
                LD      A,(IX+pYDraw)
                CP      $C9
                JR      Z,DoneAddRoom
                LD      A,(DrawIt)
                OR      A
                CALL    NZ,AddDraw
                JP      DoneAddRoom

NoAddSecColl:   CALL    RePosition
                LD      A,(IX+pXDraw)
                CP      $A1
                JR      Z,NoAddRoom
                LD      A,(IX+pYDraw)
                CP      $C9
                JR      Z,NoAddRoom
                LD      A,(DrawIt)
                OR      A
                CALL    NZ,AddDraw
                JP      DoneAddRoom

AddMainRoom:    LD      (IX+pXReal),B
                LD      (IX+pYReal),C
                LD      (IX+pZReal),D
                LD      (IX+pObjType),BlockType
                CALL    GetSize
                CALL    RePosition
                CALL    AddDraw
                CALL    AddColl
DoneAddRoom:    LD      DE,pXFrom
                ADD     IX,DE
NoAddRoom:      POP     IY
                POP     HL
                RET

AddScAnim:      RES     7,D
                LD      E,A
                LD      A,(IY+pNearNumber)
                OR      A
                LD      A,E
                LD      E,(HL)
                INC     HL
                RET     NZ
                PUSH    HL
                PUSH    IY
                LD      (IX+pSprNo),A
                LD      (IX+pXReal),B
                LD      (IX+pYReal),C
                LD      (IX+pZReal),D
                PUSH    DE
                CALL    GetSize
                POP     DE
                LD      A,E
                AND     $7F
                LD      L,A
                ADD     A,A
                ADD     A,A
                ADD     A,L
                ADD     A,LOW AnimTable
                LD      L,A
                ADC     A,HIGH AnimTable
                SUB     L
                LD      H,A
                LD      A,E
                AND     $80
                OR      (HL)
                LD      (IX+pObjType),A
                INC     HL
                LD      A,(HL)
                LD      (IX+pAnimRout+$00),A
                INC     HL
                LD      A,(HL)
                LD      (IX+pAnimRout+$01),A
                INC     HL
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                EX      DE,HL
                CALL    ZeroFroms
                CALL    ZeroTos
                CALL    CallHL
                POP     IY
                POP     HL
                POP     DE
                RET

CallHL:         JP      (HL)

PickStart:      LD      HL,$0004
                ADD     HL,SP
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                LD      A,(DE)
                LD      (IX+pAnPower),A
                CALL    RePosition
                LD      A,(IX+pSprNo)
                AND     $7F
                CP      IgnoreSprite
                CALL    C,AddDraw
                CALL    AddColl
                LD      DE,pManRoom
                ADD     IX,DE
                RET

DoorStart:      CALL    AddColl
                LD      DE,pXFrom
                ADD     IX,DE
                RET

StairStart:     LD      (IX+pZFrom),$02
                JR      DoneFrames

FrameXPlus:     LD      (IX+pXFrom),$01
                JR      DoneFrames

FrameXMin:      LD      (IX+pXFrom),$FF
                JR      DoneFrames

FrameYPlus:     LD      (IX+pYFrom),$01
                JR      DoneFrames

FrameYMin:      LD      (IX+pYFrom),$FF
DoneFrames:     CALL    RePosition
                CALL    AddDraw
                CALL    AddColl
                LD      DE,pXTo
                ADD     IX,DE
                RET

                segment data
DeedFlag:       DEFB    $FF
                segment code

ManStart:       LD      A,(DeedFlag)
                AND     $08
                ADD     A,$70
                LD      C,A
                LD      A,R
                AND     $7F
                CP      C
                JR      C,NotDeadly
                LD      A,(IX+pObjType)
                OR      $80
                LD      (IX+pObjType),A
NotDeadly:      LD      HL,$0004
                ADD     HL,SP
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                LD      A,(DE)
                LD      (IX+pAnPower),A
                LD      (IX+pDirect),$01
                LD      (IX+pAnimStep),$00
                CALL    NewStatic
                CALL    RePosition
                CALL    AddDraw
                CALL    AddAnim
                CALL    AddColl
                LD      DE,pPickSprite
                ADD     IX,DE
                RET


NewStatic:      LD      A,(IX+pSprNo)
                CP      CrucifixSprite
                RET     Z
                CALL    StaticSprite
                RET

LadderStart:    LD      (IX+pZFrom),$02
                JR      MoveStart

RatStart:       LD      HL,$0004
                ADD     HL,SP
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                LD      A,(DE)
                LD      (IX+pAnPower),A
MoveStart:      CALL    RePosition
                CALL    AddDraw
                CALL    AddAnim
                CALL    AddColl
                LD      DE,pManRoom
                ADD     IX,DE
                RET

GetSize:        LD      A,(IX+pSprNo)
                AND     $7F
                LD      HL,BlockSizeTable
                LD      DE,$0004
GetBlockSize:   CP      (HL)
                JR      C,GotBlockSize
                ADD     HL,DE
                JP      GetBlockSize
GotBlockSize:   INC     HL
                LD      C,(HL)
                INC     HL
                LD      B,(HL)
                BIT     7,(IX+pSprNo)
                JR      Z,ReversedSize
                LD      A,B
                LD      B,C
                LD      C,A
ReversedSize:   LD      (IX+pXSize),C
                LD      (IX+pYSize),B
                INC     HL
                LD      C,(HL)
                LD      (IX+pZSize),C
Ret:            RET

AnimTable:      DEFB    StairType               ;000
                DEFW    Ret,StairStart
                DEFB    MoveType                ;001
                DEFW    AnimMove,MoveStart
                DEFB    AltMoveType             ;002
                DEFW    AnimMove,MoveStart
                DEFB    DoorType                ;003
                DEFW    Ret,DoorStart
                DEFB    FrameType               ;004
                DEFW    Ret,FrameXPlus
                DEFB    FrameType               ;005
                DEFW    Ret,FrameXMin
                DEFB    FrameType               ;006
                DEFW    Ret,FrameYPlus
                DEFB    FrameType               ;007
                DEFW    Ret,FrameYMin
                DEFB    RatType                 ;008
                DEFW    AnimRat,RatStart
                DEFB    DogType                 ;009
                DEFW    DogsX,RatStart
                DEFB    PickType                ;00A
                DEFW    Ret,PickStart
                DEFB    LadderType              ;00B
                DEFW    AnimLadder,LadderStart
                DEFB    SpiderType              ;00C
                DEFW    AnimSpider,RatStart
                DEFB    BatType                 ;00D
                DEFW    AnimBat,RatStart
                DEFB    DogYType                ;00E
                DEFW    DogsY,RatStart
                DEFB    WisType                 ;00F
                DEFW    ManAnim,ManStart

Offsets:        DEFB    $00,$00,$00,$00,$00,$00
                DEFB    $00,$40,$00,$40,$20,$01
                DEFB    $40,$00,$00,$C0,$20,$02
                DEFB    $00,$C0,$00,$00,$00,$03
                DEFB    $C0,$00,$00,$00,$00,$04

RoomOffsets:    DEFB    $01,$10,$0F,$F0

BlockSizeTable: DEFB    $00+$01,$08,$08,$08
                DEFB    $04+$01,$04,$04,$08
                DEFB    $06+$01,$08,$08,$08
                DEFB    $09+$01,$08,$04,$08
                DEFB    $0E+$01,$10,$08,$08
                DEFB    $0F+$01,$08,$08,$08
                DEFB    $10+$01,$0A,$06,$10
                DEFB    $11+$01,$10,$08,$0C
                DEFB    $12+$01,$10,$08,$08
                DEFB    $13+$01,$06,$0E,$10
                DEFB    $14+$01,$08,$08,$08
                DEFB    $15+$01,$08,$08,$10
                DEFB    $16+$01,$06,$0E,$08
                DEFB    $17+$01,$06,$06,$10
                DEFB    $18+$01,$18,$10,$0C
                DEFB    $19+$01,$02,$06,$08
                DEFB    $1A+$01,$02,$02,$08
                DEFB    $1C+$01,$04,$04,$08
                DEFB    $1F+$01,$02,$02,$08
                DEFB    $20+$01,$04,$08,$08
                DEFB    $22+$01,$02,$02,$08
                DEFB    $23+$01,$06,$06,$08
                DEFB    $26+$01,$04,$04,$08
                DEFB    $27+$01,$02,$02,$08
                DEFB    $2B+$01,$02,$06,$08
                DEFB    $2F+$01,$06,$06,$08
                DEFB    $53+$01,$06,$06,$10
                DEFB    $5A+$01,$04,$0C,$08
                DEFB    $5B+$01,$04,$08,$10
                DEFB    $5F+$01,$08,$04,$04
                DEFB    $60+$01,$02,$04,$08
                DEFB    $61+$01,$04,$02,$08
                DEFB    $62+$01,$02,$02,$08
                DEFB    $63+$01,$02,$04,$08
                DEFB    $79+$01,$01,$08,$10
                DEFB    $7F+$01,$01,$01,$01

                segment data

RoomNumber:     DEFW    $0000
RoomPoint:      DEFW    $0000
RoomColour:     DEFB    $00
RoomOne:        DEFW    $0000
NearRoomOne:    DEFW    $0000
RoomTwo:        DEFW    $0000
NearRoomTwo:    DEFW    $0000
RoomThree:      DEFW    $0000
NearRoomThree:  DEFW    $0000
RoomFour:       DEFW    $0000
NearRoomFour:   DEFW    $0000
DrawIt:         DEFB    $00
FloorChar:      DEFB    $00
FreeSpace:      DEFW    $0000

                segment code
