                segment code

DrawLine        MACRO(Width)
                  LD      C,$FF
                  loop Width
                    LDI
                    lend
                  LD      A,L
                  ADD     A,B
                  LD      L,A
                  ADC     A,H
                  SUB     L
                  LD      H,A
                  IF      DummyWidth*$02-Width >= $05
                    LD      A,E
                    ADD     A,DummyWidth*$02-Width
                    LD      E,A
                    ADC     A,D
                    SUB     E
                    LD      D,A
                  ELSE
                    loop    DummyWidth*$02-Width
                      INC     DE
                      lend
                  ENDIF
                ENDM

FloorSprite:    PUSH    BC
                LD      L,A
                RES     7,L
                LD      H,HIGH SprSet
                LD      E,(HL)
                SET     7,L
                LD      D,(HL)
                RES     7,L
                INC     H
                PUSH    DE                      ;Sprite pointer
                LD      B,(HL)
                SET     7,L
                XOR     (HL)
                AND     $80
                LD      C,A
                EX      AF,AF'
                LD      A,(HL)
                XOR     C
                LD      (HL),A
                AND     $7F
                LD      C,A
                POP     HL                      ;HL' = Sprite pointer
                PUSH    BC                      ;BC' = Addwidth
                LD      B,$00
                EXX
                POP     DE                      ;DE = Height, width
                EX      AF,AF'
                CALL    NZ,Reverse
                POP     HL                      ;HL = Sprite pos Y,X
                SRL     D
                SLA     E
                LD      BC,(SizeWindX)
                SRL     B

                ;H=Sprite Pos Y
                ;L=Sprite Pos X
                ;D=Height in 2 bit slices
                ;E=Width  in 2 bit slices
                ;B=Height of window in 1 bit slices
                ;C=Width  of window in 2 bit slices

                LD      A,H
                OR      A
                JP      P,NoTopClip
                ADD     A,D
                LD      D,A
                RET     NC
                RET     Z
                LD      A,H
                NEG
                EXX
                SLA     C
TopClipLoop:    ADD     HL,BC
                DEC     A
                JR      NZ,TopClipLoop
                SRL     C
                EXX
                LD      H,A
NoTopClip:      ADD     A,D
                SUB     B
                JR      Z,NoBottClip
                JR      C,NoBottClip
                NEG
                ADD     A,D
                LD      D,A
                RET     NC
                RET     Z
NoBottClip:     LD      A,L
                OR      A
                JP      P,NoLeftClip
                ADD     A,E
                LD      E,A
                RET     NC
                RET     Z
                LD      A,L
                SRA     A
                NEG
                EXX
                ADD     A,L
                LD      L,A
                ADC     A,H
                SUB     L
                LD      H,A
                EXX
                XOR     A
                LD      L,A
NoLeftClip:     ADD     A,E
                SUB     C
                JR      Z,NoRightClip
                JR      C,NoRightClip
                NEG
                ADD     A,E
                LD      E,A
                RET     NC
                RET     Z

/*

Height to draw 2 bit slices     D
Width to draw  2 bit slices     E
Position X                      L
Position Y                      H
Sprite pointer                  HL'
Addition width                  BC'
*/

NoRightClip:    EXX
                PUSH    BC
                EXX
                POP     BC
                LD      A,D
                EX      AF,AF'
                LD      A,C
                ADD     A,A
                SUB     E
                RRA
                LD      B,A
                LD      A,E
                EX      DE,HL
                RRA
                AND     $0E
                ADD     A,LOW DrawTable
                LD      L,A
                ADC     A,HIGH DrawTable
                SUB     L
                LD      H,A
                LD      A,(HL)
                INC     HL
                LD      H,(HL)
                LD      L,A
                PUSH    HL                      ;Sprite routine pointer
                SRA     E
                LD      H,$00
                LD      A,D
                ADD     A,A
                ADD     A,A
                ADD     A,D
                ADD     A,A
                ADD     A,A
                RL      H
                LD      L,A
                LD      D,HIGH DummyScreen
                ADD     HL,DE
                EX      DE,HL
                EXX
                PUSH    HL
                EXX
                POP     HL
                EX      AF,AF'
                ADD     A,A
RetFloor:       RET

DrawTable:      DEFW    RetFloor
                DEFW    Draw002
                DEFW    Draw004
                DEFW    Draw006
                DEFW    Draw008

Draw002:        EX      AF,AF'
                DrawLine($02)
                EX      AF,AF'
                DEC     A
                JP      NZ,Draw002
                RET

Draw004:        EX      AF,AF'
                DrawLine($04)
                EX      AF,AF'
                DEC     A
                JP      NZ,Draw004
                RET

Draw006:        EX      AF,AF'
                DrawLine($06)
                EX      AF,AF'
                DEC     A
                JP      NZ,Draw006
                RET

Draw008:        EX      AF,AF'
                DrawLine($08)
                EX      AF,AF'
                DEC     A
                JP      NZ,Draw008
                RET

