                segment code
NewGame:        DI
                LD      SP,StartStack
                CALL    SetIntTable
                LD      A,$00
                LD      (Seconds),A
                LD      IX,JohnList
                LD      (ManList),IX
                LD      A,(GameType)
                OR      A
                JR      NZ,SetGameTwo
                LD      BC,$3832
                LD      E,$00
                LD      D,ManSprite
                LD      HL,$C0A8
                CALL    SetMan
                LD      IX,NosyList
                LD      D,NosySprite
                LD      BC,$0038
                LD      E,$00
                LD      HL,$0055
                CALL    SetNosy
                CALL    SetUpDeeds
                JP      DoneSetUp
SetGameTwo:     LD      BC,$001C
                LD      E,$24
                LD      D,ManSprite
                LD      HL,$1C20
                CALL    SetMan
                LD      IX,NosyList
                LD      D,NosySprite
                LD      BC,$2000
                LD      E,$00
                LD      HL,$0063
                LD      A,(DeedFlag)
                OR      A
                JR      NZ,SetNosyDeed
                LD      BC,$1020
                LD      E,$00
                LD      HL,$0026
SetNosyDeed:    CALL    SetNosy
                LD      IX,LucyList
                LD      BC,$1838
                LD      B,$18
                LD      E,$00
                LD      D,LucySprite
                LD      HL,$0022
                CALL    SetMan
                LD      IX,VanList
                LD      BC,$2838
                LD      E,$00
                LD      D,ManSprite
                LD      HL,$0022
                CALL    SetMan
DoneSetUp:      LD      DE,(InitObjects)
                LD      HL,(EndObjects)
                OR      A
                SBC     HL,DE
                LD      B,H
                LD      C,L
                EX      DE,HL
                LD      DE,(Objects)
                LDIR
                LD      (FreeSpace),DE
OldGame:        LD      SP,StartStack
                CALL    SetIntTable
                CALL    SetTables
                LD      DE,Nos1Tune
                LD      A,$00
                CALL    AddTune
                LD      HL,$0000
                LD      (RoomNumber),HL
                LD      IX,(ManList)
                LD      A,$00
                LD      (IX+pAnimStep),A
                LD      E,(IX+pManRoom+$00)
                LD      D,(IX+pManRoom+$01)
                CALL    NewRoom
                EI
MainLoop:       CALL    ScanKeys
ModKeys         EQU     $-$02
                CALL    MoveMan
                LD      A,(GameType)
                OR      A
                JR      NZ,MultiGame
                LD      A,(JohnList+pPower)
                OR      A
                JP      Z,EndGame
                JP      GameOne
MultiGame:      CALL    MultiCheck
                LD      A,(LucyList+pPower)
                OR      A
                JP      Z,EndGame
GameOne:        CALL    Animate
                CALL    CheckQuit
                CALL    MoonSun
                CALL    WaitInterupt
                JP      MainLoop

                segment data

        if enabled bBuildPartOne
GameType:       DEFB    $00
        else
GameType:       DEFB    $01
        endif

                segment code

SetUpDeeds:     LD      IX,(PlaceDeeds)
                LD      B,$08
                LD      DE,$0008
ClrDeedLp:      LD      A,R
                AND     $03
                ADD     A,CandelSprite
                LD      (IX+$05),A
                ADD     IX,DE
                DJNZ    ClrDeedLp
                LD      A,R
                AND     $07
                ADD     A,A
                ADD     A,A
                ADD     A,A
                LD      E,A
                LD      D,$00
                LD      HL,(PlaceDeeds)
                ADD     HL,DE
                LD      DE,$0005
                ADD     HL,DE
                LD      (HL),DeedSprite
                RET

SetMan:         XOR     A
                LD      (IX+pPickSprite),A
                LD      (IX+pPickType),A
                LD      (IX+pWeapSprite),A
                LD      (IX+pWeapType),A
                LD      (IX+pDrunk),A
SetNosy:        LD      (IX+pXReal),C
                LD      (IX+pYReal),B
                LD      (IX+pZReal),E
                LD      (IX+pSprNo),D
                LD      A,$01
                LD      (IX+pDirect),A
                LD      A,MaxPower
                LD      (IX+pPower),A
                LD      (IX+pLastPower),A
                LD      (IX+pManRoom+000),L
                LD      (IX+pManRoom+001),H
                RET

CheckQuit:      LD      A,$09
                IN      A,($FE)
                OR      $E0
                INC     A
                RET     NZ
                LD      A,$FE
                IN      A,($FE)
                AND     $01
                RET     NZ
                LD      A,$F7
                IN      A,($FE)
                BIT     0,A
                JR      Z,ToggleSound
                AND     $0C
                RET     NZ
                CALL    CompactOld
                CALL    MenCompactOld
                LD      A,$01
                JP      EndGame


ToggleSound:    LD      A,$F7
                IN      A,($FE)
                RRA
                JR      NC,ToggleSound
                LD      A,(SoundFlag)
                CPL
                LD      (SoundFlag),A
                OR      A
                JP      NZ,KillSound
                LD      DE,Nos1Tune
                LD      A,$00
                CALL    AddTune
                RET

                segment data
SoundFlag:      DEFB    $00
                segment code


WaitInterupt:   LD      A,(IntCount)
                CP      $03
                JR      C,WaitInterupt
                LD      A,$00
                LD      (IntCount),A
                RET

Interupt:       DI
                PUSH    AF
                PUSH    BC
                PUSH    HL
                PUSH    DE
                CALL    DoTime
                CALL    DoSound
                POP     DE
                LD      A,(IntCount)
                INC     A
                LD      (IntCount),A
                POP     HL
                POP     BC
                POP     AF
                EI
                RET

DoTime:         LD      HL,Jiffys
                INC     (HL)
                LD      A,(HL)
                CP      $32
                RET     NZ
                XOR     A
                LD      (HL),A
                LD      HL,Seconds
                INC     (HL)
                RET

                segment data
IntCount:       DEFB    000
IntNum:         DEFB    000
Seconds:        DEFB    000
Jiffys:         DEFB    000
QuitCount:      DEFB    001
                segment code


