                segment code

NumberKeys      EQU     $05

Kempston:       LD      B,NumberKeys
                LD      HL,KempTable
                LD      DE,BounceTable
KempLoop:       IN      A,($1F)  // Bug? Was $FE
                AND     (HL)
                CPL
                INC     HL
                CALL    ProcessKey
                DJNZ    KempLoop
                JR      ScanChange

ScanKeys:       LD      HL,KeyTable
                JR      DoKeys

Sinclair:       LD      HL,SincTable
                JR      DoKeys

Protek:         LD      HL,ProtTable
DoKeys:         LD      B,NumberKeys
                LD      DE,BounceTable
                CALL    ScanKeyLoop
ScanChange:     LD      B,$03
                LD      HL,ChangeTab
ScanKeyLoop:    LD      A,(HL)
                IN      A,($FE)
                INC     HL
                OR      (HL)
                INC     HL
                CALL    ProcessKey
                DJNZ    ScanKeyLoop
                RET

ProcessKey:     INC     A
                JR      Z,NotPressed
                LD      A,(DE)
                OR      A
                JR      NZ,PressedLast
                LD      A,$FF
                LD      (DE),A
                INC     DE
                LD      (DE),A
                INC     DE
                RET

NotPressed:     XOR     A
                LD      (DE),A
PressedLast:    INC     DE
                INC     DE
                RET

ReadKey:        INC     HL
                LD      A,(HL)
                OR      A
                LD      (HL),000
                RET

                segment data

BounceTable:    DEFW    $0000
                DEFW    $0000
                DEFW    $0000
                DEFW    $0000
                DEFW    $0000
                DEFW    $0000
                DEFW    $0000
                DEFW    $0000

                segment code

KeyTable:       DEFB    $FE,$FD         ;Z
                DEFB    $FE,$FB         ;X
                DEFB    $7F,$F7         ;N
                DEFB    $7F,$FB         ;M
                DEFB    $7F,$FD         ;,

ChangeTab:      DEFB    $F7,$FE
                DEFB    $F7,$FD
                DEFB    $F7,$FB

SincTable:      DEFB    $EF,$EF
                DEFB    $EF,$F7
                DEFB    $EF,$FD
                DEFB    $EF,$FB
                DEFB    $EF,$FE

ProtTable:      DEFB    $F7,$EF
                DEFB    $EF,$FB
                DEFB    $EF,$F7
                DEFB    $EF,$EF
                DEFB    $EF,$FE

KempTable:      DEFB    $02
                DEFB    $01
                DEFB    $08
                DEFB    $04
                DEFB    $10
