                segment code

SaveGame:       LD      (LoadFileName),HL
                CALL    Print
                DEFB    $0D
                DEFB    "Press PLAY and REC then any key.",$0D
                DEFB    $FF
                CALL    WaitKey
                CALL    Print
                DEFB    "Saving "
                DEFB    $FF
                LD      HL,(LoadFileName)
                CALL    PrtFileName
                LD      HL,(LoadFileName)
                LD      DE,Header+$01
                LD      BC,$000A
                LDIR
                LD      IX,Header
                LD      DE,$0011
                XOR     A
                CALL    CasWrite
                LD      BC,$0000
Wait:           DEC     BC
                LD      A,B
                OR      C
                JR      NZ,Wait
                LD      IX,$5B00
                LD      DE,$1AF0
                LD      A,$FF
                CALL    CasWrite
                RET

                segment data
TempBlock:      DEFS    $0011,$00
Header:         DEFB    $03
                DEFS    $000A,$20
                DEFW    $1AF0
                DEFW    $5B00
                DEFW    $1AF0
LoadFileName:   DEFW    $0000
                segment code

LoadGame:       LD      (LoadFileName),HL
                CALL    Print
                DEFB    $0D
                DEFB    "Searching for "
                DEFB    $FF
                LD      HL,(LoadFileName)
                CALL    PrtFileName
ReRead:         LD      IX,TempBlock
                LD      DE,$0011
                XOR     A
                CALL    CasRead
                RET     NC
                CALL    Print
                DEFB    $0D
                DEFB    "Found "
                DEFB    $FF
                LD      HL,TempBlock+$01
                CALL    PrtFileName
                LD      HL,(LoadFileName)
                LD      B,$0A
                LD      DE,TempBlock+$01
ChkFileName:    LD      A,(DE)
                CP      (HL)
                JR      NZ,ReRead
                INC     HL
                INC     DE
                DJNZ    ChkFileName
                LD      IX,$5B00
                LD      DE,$1AF0
                LD      A,$FF
                CALL    CasRead
                RET

StartLoad:      LD      (LoadFileName),HL
ReRead1:        LD      IX,TempBlock
                LD      DE,$0011
                XOR     A
                CALL    CasRead
                RET     NC
                LD      HL,(LoadFileName)
                LD      B,$0A
                LD      DE,TempBlock+$01
ChkFileName1:   LD      A,(DE)
                CP      (HL)
                JR      NZ,ReRead1
                INC     HL
                INC     DE
                DJNZ    ChkFileName1
                LD      IX,$5B00
                LD      DE,$1AF0
                LD      A,$FF
                CALL    CasRead
                RET

PrtFileName:    LD      B,$0A
PrtFileLp:      PUSH    HL
                PUSH    BC
                LD      A,(HL)
                CALL    CharOut
                POP     BC
                POP     HL
                INC     HL
                DJNZ    PrtFileLp
                RET

WaitKey:        XOR     A
                IN      A,($FE)
                OR      $E0
                INC     A
                JR      NZ,WaitKey
WaitKey2:       XOR     A
                IN      A,($FE)
                OR      $E0
                INC     A
                JR      Z,WaitKey2
                RET

CasWrite:       DI
                LD      HL,EndTape
                PUSH    HL
                LD      HL,$1F80        ;A =FileType
                BIT     7,A             ;IX=Start
                JR      Z,A04D0         ;DE=Length
                LD      HL,$0C98
A04D0:          EX      AF,AF'
                INC     DE
                DEC     IX
                LD      A,$01
                LD      B,A
A04D8:          DJNZ    A04D8
                OUT     ($FE),A
                XOR     $09
                LD      B,$A4
                DEC     L
                JR      NZ,A04D8
                DEC     B
                DEC     H
                JP      P,A04D8
                LD      B,$2F
A04EA:          DJNZ    A04EA
                OUT     ($FE),A
                LD      A,$09
                LD      B,$37
A04F2:          DJNZ    A04F2
                OUT     ($FE),A
                LD      BC,$3B08
                EX      AF,AF'
                LD      L,A
                JP      A0507

A04FE:          LD      A,D
                OR      E
                JR      Z,A050E
                LD      L,(IX+$00)
A0505:          LD      A,H
                XOR     L
A0507:          LD      H,A
                LD      A,$01
                SCF
                JP      A0525

A050E:          LD      L,H
                JR      A0505

A0511:          LD      A,C
                BIT     7,B
A0514:          DJNZ    A0514
                JR      NC,A051C
                LD      B,$42
A051A:          DJNZ    A051A
A051C:          OUT     ($FE),A
                LD      B,$3E
                JR      NZ,A0511
                DEC     B
                XOR     A
                INC     A
A0525:          RL      L
                JP      NZ,A0514
                DEC     DE
                INC     IX
                LD      B,$31
                LD      A,$7F
                IN      A,($FE)
                RRA
                RET     NC
                LD      A,D
                INC     A
                JP      NZ,A04FE
                LD      B,$3B
A053C:          DJNZ    A053C
                RET                     ;EndSave
CasRead:        DI
                LD      HL,EndTape
                PUSH    HL
                INC     D
                EX      AF,AF'
                DEC     D
                LD      A,$0F
                OUT     ($FE),A
A0562:          IN      A,($FE)
                RRA
                AND     $20
                OR      $01
                LD      C,A
                CP      A
A056B:          RET     NZ
A056C:          CALL    A05E7
                JR      NC,A056B
                LD      HL,$0415
A0574:          DJNZ    A0574
                DEC     HL
                LD      A,H
                OR      L
                JR      NZ,A0574
                CALL    A05E3
                JR      NC,A056B
A0580:          LD      B,$9C
                CALL    A05E3
                JR      NC,A056B
                LD      A,$C6
                CP      B
                JR      NC,A056C
                INC     H
                JR      NZ,A0580
A058F:          LD      B,$C9
                CALL    A05E7
                JR      NC,A056B
                LD      A,B
                CP      $D4
                JR      NC,A058F
                CALL    A05E7
                RET     NC
                LD      A,C
                XOR     $01
                LD      C,A
                LD      H,$00
                LD      B,$B0
                JR      A05C8

A05A9:          EX      AF,AF'
                JR      NZ,A05B3
                LD      (IX+$00),L
                JR      A05C2

A05B3:          RL      C
                XOR     L
                RET     NZ
                LD      A,C
                RRA
                LD      C,A
                INC     DE
                JR      A05C4

A05C2:          INC     IX
A05C4:          DEC     DE
                EX      AF,AF'
                LD      B,$B2
A05C8:          LD      L,$01
A05CA:          CALL    A05E3
                RET     NC
                LD      A,$CB
                CP      B
                RL      L
                LD      B,$B0
                JP      NC,A05CA
                LD      A,H
                XOR     L
                LD      H,A
                LD      A,D
                OR      E
                JR      NZ,A05A9
                LD      A,H
                CP      $01
                RET

A05E3:          CALL    A05E7
                RET     NC
A05E7:          LD      A,$16
A05E9:          DEC     A
                JR      NZ,A05E9
                AND     A
A05ED:          INC     B
                RET     Z
                LD      A,$7F
                IN      A,($FE)
                RRA
                RET     NC
                XOR     C
                AND     $20
                JR      Z,A05ED
                LD      A,C
                XOR     $F9
                LD      C,A
                AND     $07
                OR      $08
                OUT     ($FE),A
                SCF
                RET

EndTape:        PUSH    AF
                XOR     A
                OUT     ($FE),A
                POP     AF
                EI
                RET
