; These are Graham's Nosferatu sources converted to Zeus.

; I don't know why he used hexadecimal numbers for everything
; but that's faithful to the original source.

; Should assemble and run if you click on Assemble then Emulate

                INCLUDE "equates.inc"

bBuildPartOne   EQU     true    ; We are building part one
;bCompressTape   equ     true    ; Compress the data to speed up tape loading

Black           EQU     $00
Blue            EQU     $ 41
Red             EQU     $42
Magenta         EQU     $43
Green           EQU     $44
Cyan            EQU     $45
Yellow          EQU     $46
White           EQU     $47

PrintAt         MACRO(X,Y)
                DEFB    $03,X,Y
                ENDM

SetAttr         MACRO(Colour)
                DEFB    $04,Colour
                ENDM

Cls             MACRO()
                DEFB    $02
                ENDM

Return          MACRO(NumReturn)
                loop NumReturn
                DEFB    $0D
                lend
                ENDM

Spaces          MACRO(Number)
                DEFB    $08,Number
                ENDM

EndString       MACRO()
                DEFB    $FF
                ENDM

                segment code

FrontBegin:     LD      SP,StartStack
                LD      HL,Part1Name
                CALL    StartLoad
FrontEmulated   LD      A,$00
                LD      (DoneNew),A
FrontMain:      DI
                LD      SP,StartStack

                CALL    Print

                Cls()
                PrintAt($05,$01)
                SetAttr(Yellow)
                DEFB    $85," ",$86,"Vampyre"
                Return(2)
                SetAttr(White)
                DEFB    $80
                SetAttr(Magenta)
                DEFB    $87,"NEW",$88
                Return(3)
                SetAttr(White)
                DEFB    $81
                SetAttr(Cyan)
                DEFB    $87,"OLD",$88
                Return(3)
                SetAttr(White)
                DEFB    $82
                SetAttr(Green)
                DEFB    "Define ",$86,"playing keys"
                Return(3)
                SetAttr(White)
                DEFB    $83
                SetAttr(Yellow)
                DEFB    "S",$8A," a ",$8B
                Return(3)
                SetAttr(White)
                DEFB    $84
                SetAttr(Red)
                DEFB    $8C
                Return(3)
                SetAttr(White)
                DEFB    "6 "
                SetAttr(Magenta)
                DEFB    "Load old",$88
                Return(3)
                SetAttr(White)
                DEFB    "7 "
                SetAttr(Cyan)
                DEFB    "Save p",$8D,$88
                Return(2)
                SetAttr(Blue)
                DEFB    "(c) 1986 Macmillan"
                EndString()

SillyLoop:      CALL    FrontKeys
                CP      "1"
                JR      Z,GoGame
                CP      "2"
                JR      Z,GoOldGame
                CP      "3"
                JP      Z,Define
                CP      "4"
                JP      Z,Joystick
                CP      "5"
                JP      Z,Instruct
                CP      "6"
                JP      Z,LoadBlock
                CP      "7"
                JP      Z,SaveBlock
                JP      SillyLoop

                segment data
DoneNew:        DEFB    $FF
                segment code

GoGame:         CALL    Print
                Cls()
                EndString()
                LD      A,$FF
                LD      (DoneNew),A
                LD      HL,$0000
                LD      (Score),HL
                JP      NewGame

GoOldGame:      LD      A,(DoneNew)
                OR      A
                JP      Z,SillyLoop
                CALL    Print
                Cls()
                EndString()
                JP      OldGame

LoadBlock:      CALL    Print
                Cls()
                PrintAt($0F,$00)
                SetAttr(Magenta)
                DEFB    "LOAD",$89
                Return(2)
                EndString()
                CALL    GetFileName
                LD      A,B
                OR      A
                JP      Z,FrontMain
                LD      HL,FileName
                CALL    LoadGame
                JP      FrontMain

SaveBlock:      CALL    Print
                Cls()
                PrintAt($0F,$00)
                SetAttr(Magenta)
                DEFB    "SAVE",$89
                Return(2)
                EndString()
                CALL    GetFileName
                LD      A,B
                OR      A
                JP      Z,FrontMain
                LD      HL,FileName
                CALL    SaveGame
                JP      FrontMain

GetFileName:    LD      B,$0A
                LD      HL,FileName
ClrNameLp:      LD      (HL)," "
                INC     HL
                DJNZ    ClrNameLp
                CALL    Print
                PrintAt($00,$02)
                DEFB    "Filename ? "
                EndString()

                LD      HL,FileName
                LD      B,$00
FileNameLp:     PUSH    HL
                PUSH    BC
NoKey:          CALL    FrontKeys
                OR      A
                JR      Z,NoKey
                POP     BC
                POP     HL
                CP      $0D
                RET     Z
                CP      $7F
                JR      Z,DoDelete
                CALL    CheckAscii
                JR      C,FileNameLp
                EX      AF,AF'
                LD      A,B
                CP      $0A
                JR      NC,FileNameLp
                EX      AF,AF'
                LD      (HL),A
                PUSH    HL
                PUSH    BC
                CALL    CharOut
                POP     BC
                POP     HL
                INC     HL
                INC     B
                JP      FileNameLp

CheckAscii:     CP      "0"
                RET     C
                CP      "9"+$01
                CCF
                RET     NC
                CP      "A"
                RET     C
                CP      "Z"+$01
                CCF
                RET     NC
                CP      "a"
                RET     C
                CP      "z"+$01
                CCF
                RET

DoDelete:       LD      A,B
                OR      A
                JR      Z,FileNameLp
                DEC     B
                LD      (HL)," "
                DEC     HL
                CALL    KillChar
                PUSH    BC
                PUSH    HL
                LD      A," "
                CALL    CharOut
                POP     HL
                POP     BC
                CALL    KillChar
                JP      FileNameLp

KillChar:       PUSH    HL
                PUSH    BC
                LD      A,$03
                CALL    CharOut
                POP     BC
                PUSH    BC
                LD      A,B
                ADD     A,$0B
                CALL    CharOut
                LD      A,$02
                CALL    CharOut
                POP     BC
                POP     HL
                RET

Define:         CALL    Print

                Cls()
                PrintAt($0F,$00)
                SetAttr(Magenta)
                DEFB    "P",$8D," Controls"
                Return(2)
                SetAttr(White)
                DEFB    $80
                SetAttr(Green)
                DEFB    "Left"
                Return(2)
                SetAttr(White)
                DEFB    $81
                SetAttr(Cyan)
                DEFB    "Right"
                Return(2)
                SetAttr(White)
                DEFB    $82
                SetAttr(Yellow)
                DEFB    "Forwards"
                Return(2)
                SetAttr(White)
                DEFB    $83
                SetAttr(Magenta)
                DEFB    "Backwards"
                Return(2)
                SetAttr(White)
                DEFB    $84
                SetAttr(Red)
                DEFB    $8E
                Return(2)
                DEFB    "  ",$8F
                Return ($0A)
                SetAttr(White)
                DEFB    "0"
                SetAttr(Magenta)
                DEFB    " R",$90
                EndString()

DefineLoop:     LD      HL,KeyTable
                LD      B,$05
                LD      C,$02
PrintDefsLp:    PUSH    BC
                CALL    Print
                DEFB    $03,$11
                EndString()
                LD      A,C
                CALL    CharOut
                CALL    Print
                Spaces($0A)
                SetAttr(Cyan)
                EndString()
                CALL    Print
                DEFB    $03,$11
                EndString()
                LD      A,C
                CALL    CharOut
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                INC     HL
                PUSH    HL
                CALL    PrintKey
                POP     HL
                POP     BC
                INC     C
                INC     C
                DJNZ    PrintDefsLp
WaitDefLoop:    CALL    FrontKeys
                CP      "0"
                JP      Z,FrontMain
                CP      "1"
                JR      Z,DefLeft
                CP      "2"
                JR      Z,DefRight
                CP      "3"
                JR      Z,DefFire
                CP      "4"
                JR      Z,DefThrust
                CP      "5"
                JR      Z,DefCentre
                JP      WaitDefLoop

DefLeft:        CALL    Print
                PrintAt($10,$02)
                EndString()
                LD      HL,KeyTable+$00
                JP      DoDefine

DefRight:       CALL    Print
                PrintAt($10,$04)
                EndString()
                LD      HL,KeyTable+$02
                JP      DoDefine

DefFire:        CALL    Print
                PrintAt($10,$06)
                EndString()
                LD      HL,KeyTable+$04
                JP      DoDefine

DefThrust:      CALL    Print
                PrintAt($10,$08)
                EndString()
                LD      HL,KeyTable+$06
                JP      DoDefine

DefCentre:      CALL    Print
                PrintAt($11,$0A)
                EndString()
                LD      HL,KeyTable+$08
DoDefine:       XOR     A
                IN      A,($FE)
                OR      $E0
                INC     A
                JR      NZ,DoDefine
                CALL    Print
                Spaces($0A)
                EndString()
ReDoDefine:     LD      D,$10
DefineOuter:    LD      E,$7F
DefineInner:    LD      A,E
                CP      $F7
                JR      Z,RepeatDefine
                IN      A,($FE)
                AND     D
                JR      Z,GotDefine
RepeatDefine:   RRC     E
                JR      C,DefineInner
                RRC     D
                JR      NC,DefineOuter
                JP      ReDoDefine
GotDefine:      LD      A,D
                CPL
                LD      (HL),E
                INC     HL
                LD      (HL),A
                JP      DefineLoop

Joystick:       CALL    Print

                Cls()
                EndString()

JoyPrtLoop:     LD      D,$01
                CALL    Print
                PrintAt($07,$00)
                SetAttr(Yellow)
                DEFM    $8B,"S",$8A,"ion"
                Return(2)
                SetAttr(White)
                DEFM    $80
                SetAttr(Cyan)
                DEFM    "Keyboard"
                Return(2)
                SetAttr(White)
                DEFM    $81
                SetAttr(Green)
                DEFM    "Kempston"
                Return(2)
                SetAttr(White)
                DEFM    $82
                SetAttr(Magenta)
                DEFM    "Protek"
                Return(2)
                SetAttr(White)
                DEFM    $83
                SetAttr(Red)
                DEFM    "Sinclair Interface 2"
                PrintAt($00,$17)
                SetAttr(White)
                DEFM    "0"
                SetAttr(Magenta)
                DEFM    " R",$90
                EndString()

JoyOutLoop:     LD      B,$05
JoyInLoop:      CALL    FrontKeys
                LD      HL,ScanKeys
                LD      C,$02
                CP      "1"
                JR      Z,GotJoy
                LD      HL,Kempston
                LD      C,$04
                CP      "2"
                JR      Z,GotJoy
                LD      HL,Protek
                LD      C,$06
                CP      "3"
                JR      Z,GotJoy
                LD      HL,Sinclair
                LD      C,$08
                CP      "4"
                JR      Z,GotJoy
                CP      "0"
                JP      Z,FrontMain
                DJNZ    JoyInLoop
                LD      A,D
                OR      A
                JP      Z,JoyPrtLoop
                LD      D,$00
                CALL    Print
                DEFB    $03,$02
                EndString()
                LD      A,(SelJoy)
                CALL    CharOut
                CALL    Print
                Spaces($14)
                EndString()
                JP      JoyOutLoop
GotJoy:         LD      A,C
                LD      (SelJoy),A
                LD      (ModKeys),HL
                JP      JoyPrtLoop

                segment data
SelJoy:         DEFB    $02
FileName:       DEFS    $0010,$00
                segment code

Instruct:       CALL    Print

                Cls()
                PrintAt($07,$00)
                SetAttr(Magenta)
                DEFB    "Brief ",$8C
                Return(2)
                SetAttr(Green)
                DEFB    "In part one escape from ",$86
                Return(2)
                DEFB    "castle."
                Return(3)
                SetAttr(Cyan)
                DEFB    "In part two lure ",$85," to"
                Return(2)
                DEFB    "Lucy's  bedroom to kill him."
                Return(3)
                SetAttr(Magenta)
                DEFB    "To return to ",$86,"main menu press"
                Return(2)
                DEFB    "'Caps', '3' and '4'."
                Return(2)
                SetAttr(Yellow)
                DEFB    "'Caps' and '1' to toggle"
                Return(2)
                DEFB    $86," tune on/off."
                EndString()
                CALL    PressSpace
                JP      FrontMain

PressSpace:     CALL    Print

                PrintAt($05,$17)
                SetAttr(Magenta)
                DEFM    "Press "
                SetAttr(White)
                DEFM    "SPACE"
                SetAttr(Magenta)
                DEFM    " to continue"
                EndString()

WaitNoSpc:      CALL    FrontKeys
                CP      " "
                JR      Z,WaitNoSpc
WaitSpace:      CALL    FrontKeys
                CP      " "
                JR      NZ,WaitSpace
                RET

PrintKey:       PUSH    DE
                LD      HL,ScanTable
                LD      BC,$0005
GetRowDef:      RR      D
                JR      NC,GetColumnDef
                INC     HL
                JP      GetRowDef
GetColumnDef:   RR      E
                JR      NC,GotColumnDef
                ADD     HL,BC
                JP      GetColumnDef
GotColumnDef:   POP     DE
                LD      A,(HL)
                CP      " "
                JR      Z,ItsSpace
                CP      $0D
                JR      Z,Enter
                CALL    CharOut
                RET

ItsSpace:       LD      A,$92
                CALL    CharOut
                RET

Enter:          LD      A,$94
                CALL    CharOut
                RET

EndGame:        DI
                LD      SP,StartStack
                OR      A
                JP      Z,Killed
                DEC     A
                JP      Z,FrontMain
                LD      A,(GameType)
                OR      A
                JP      Z,EscPartOne

                CALL    Print
                Cls()
                PrintAt($00,$00)
                SetAttr(Magenta)
                DEFB    $91,"killed"
                DEFB    $0D
                DEFB    $85,"."
                DEFB    $0D
                EndString()
                LD      DE,$03E8
                LD      A,(VanList+pPower)
                OR      A
                CALL    NZ,AddScore
                EX      AF,AF'
                LD      A,(JohnList+pPower)
                OR      A
                CALL    NZ,AddScore
                JR      Z,OneDead
                EX      AF,AF'
                JR      Z,OneDead
                LD      A,(JohnList+pManRoom+$00)
                LD      E,A
                LD      A,(JohnList+pManRoom+$01)
                LD      D,A
                LD      A,(JohnList+pManRoom+$00)
                LD      L,A
                LD      A,(JohnList+pManRoom+$01)
                LD      H,A
                OR      A
                SBC     HL,DE
                JR      Z,OneDead
                LD      DE,$03E8
                CALL    AddScore
OneDead:        LD      DE,$1388
                CALL    AddScore
                CALL    TellScore
                CALL    PressSpace
                JP      FrontMain

EscPartOne:     CALL    Print
                Cls()
                PrintAt($00,$00)
                SetAttr(Magenta)
                DEFB    $91,"escaped",$0D
                DEFB    "from ",$86," castle.",$0D
                EndString()
                LD      DE,$03E8
                CALL    AddScore
                LD      A,$00
                LD      (DeedHack),A
                LD      A,(JohnList+pPickSprite)
                CP      DeedSprite
                JR      NZ,NoDeeds
                LD      A,$FF
                LD      (DeedHack),A
                LD      DE,$0BB8
                CALL    AddScore
                CALL    Print
                DEFB    "You collected ",$86," deeds.",$0D
                EndString()
NoDeeds:        LD      HL,(Score)
                LD      (ScoreHack),HL
                CALL    Print
                DEFB    "Now load part two.",$0D
                EndString()
                LD      B,$06
                LD      HL,Part2Name
                CALL    LoadGame
                LD      A,$00
DeedHack        EQU     $-$01
                LD      (DeedFlag),A
                LD      A,$FF
                LD      (GameType),A
                LD      HL,$00000
ScoreHack       EQU     $-$02
                LD      (Score),HL
                JP      FrontMain

Part1Name:      DEFB    "PART#1    "
Part2Name:      DEFB    "PART#2    "

Killed:         CALL    Print

                Cls()
                PrintAt($00,$00)
                SetAttr(Magenta)
                DEFB    "You have been killed."
                EndString()
                CALL    TellScore
                CALL    PressSpace
                JP      FrontMain

TellScore:      CALL    Print
                SetAttr(Red)
                DEFB    $0D
                DEFB    "and scored "
                EndString()
                LD      HL,(Score)
                CALL    PrintDec
                CALL    Print
                DEFB    " points."
                EndString()
                RET

PrintDec:       LD      A,H
                OR      L
                JR      Z,NoDecPrt
                LD      IX,Powers
                LD      B,$04
                LD      C,$00
ScoreLoop:      XOR     A
                LD      E,(IX+$00)
                LD      D,(IX+$01)
InnerLoop:      INC     A
                OR      A
                SBC     HL,DE
                JR      NC,InnerLoop
                DEC     A
                JR      Z,ItsAZero
                LD      C,$30
ItsAZero:       ADD     A,C
                ADD     HL,DE
                PUSH    HL
                PUSH    BC
                CALL    CharOut
                POP     BC
                POP     HL
                INC     IX
                INC     IX
                DJNZ    ScoreLoop
                LD      A,L
                OR      A
                JR      Z,ItsNextZero
                LD      C,$30
ItsNextZero:    ADD     A,C
                CALL    CharOut
                RET

AddScore:       LD      HL,(Score)
                ADD     HL,DE
                LD      (Score),HL
                RET

Powers:         DEFW    10000
                DEFW    1000
                DEFW    100
                DEFW    10

NoDecPrt:       CALL    Print
                DEFB    "no"
                EndString()
                RET

FrontKeys:      PUSH    HL
                PUSH    DE
                PUSH    BC
                LD      A,(PreviousKey)
                LD      D,A
                LD      HL,KeyDelay
                LD      B,(HL)
                LD      C,$80
                LD      A,D
                LD      (LastKey),A
SameKey:        CALL    ScanRoutine
                LD      D,A
                LD      A,(LastKey)
                CP      D
                JR      NZ,KeyChange
                DEC     BC
                LD      A,B
                OR      C
                JR      NZ,SameKey
KeyChange:      LD      C,$00
                LD      A,D
                OR      A
                JR      Z,NoLastKey
                LD      C,$01
                LD      A,(PreviousKey)
                CP      D
                JR      Z,NoLastKey
                LD      C,$04
NoLastKey:      LD      A,C
                LD      (KeyDelay),A
                LD      A,D
                LD      (PreviousKey),A
                POP     BC
                POP     DE
                POP     HL
                OR      A
                RET

                segment data
LastKey:        DEFB    $00
PreviousKey:    DEFB    $00
KeyDelay:       DEFB    $00
                segment code

ScanRoutine:    PUSH    BC
                LD      D,$10
ScanOuter:      LD      E,$7F
ScanInner:      LD      A,E
                IN      A,($FE)
                AND     D
                JR      Z,KeyDown
RepeatScan:     RRC     E
                JR      C,ScanInner
                RRC     D
                JR      NC,ScanOuter
                POP     BC
                XOR     A
                RET
KeyDown:        PUSH    DE
                LD      HL,ScanTable
                LD      BC,$0005
GetRow:         RR      D
                JR      C,GetColumn
                INC     HL
                JP      GetRow
GetColumn:      RR      E
                JR      NC,GotColumn
                ADD     HL,BC
                JP      GetColumn
GotColumn:      POP     DE
                LD      A,(HL)
                OR      A
                JP      M,RepeatScan
                POP     BC
                LD      A,(HL)
                OR      A
                RET

ScanTable:      DEFB    $93
                DEFM    "ZXCVASDFGQWERT12345"
                DEFM    "09876POIUY"
                DEFB    $0D
                DEFM    "LKJH "
                DEFB    $95
                DEFM    "MNB"

                segment data
Score:          DEFW    $0000
                segment code

                include "game.inc"
                include "prints.inc"
                include "setups.inc"
                include "expands.inc"
                include "moveman.inc"
                include "keyscan.inc"
                include "anims.inc"
                include "sound.inc"
                include "dolist.inc"
                include "lists.inc"
                include "draws.inc"
                include "collide.inc"
                include "sprites.inc"
                include "clears.inc"
                include "outs.inc"
                include "rotates.inc"
                include "reverse.inc"
                include "loaders.inc"
                include "floors.inc"
                include "rooms.inc"

; Information for Zeus's emulation

        if zeusver >= 44
                zeusemulate "48K","RAW"         ; "RAW" means don't start as if called from BASIC
        else
                zeusemulate "48K"               ; We can live without it. Some data gets overwritten?
        endif

                ; Tell Zeus's emulator where to start emulating

                Zeus_PC=FrontEmulated
                Zeus_SP=0

                ; Load the loading screen so we can generate a tape loader

                import_bin "screen.bin",$4000   ; The original screen

                ; And get Zeus to generate a tzx file with a loader and really foul loading colours ;)
                ; Note that the tape version should require another block of data to be added to the tzx file.
                ; If you intend to do that replace FrontEmulated with FrontBegin below.

        if enabled bCompressTape
                zeuscompress $5B00,DummyScreen,FrontEmulated
                output_tzx "nosferatu.tzx","nosferatu","nosferatu",$5B00,$C900-$5B00,1,$5B00,$00123456
        else

                output_tzx "nosferatu.tzx","nosferatu","nosferatu",$5B00,DummyScreen-$5B00,1,FrontEmulated,$00123456
        endif

;        export_sym "",$4000     ; Tell Zeus to export the symbol table in Diana format

        zeusdatafollows Print   ; Tell Zeus that the "Print" call has data planted after it.
