                segment code

Black           EQU     $00
Blue            EQU     $41
Red             EQU     $42
Magenta         EQU     $43
Green           EQU     $44
Cyan            EQU     $45
Yellow          EQU     $46
White           EQU     $47

CharSet         EQU     $3C00

Print:          EX      (SP),HL
                CALL    HLPrint
                EX      (SP),HL
                RET

HLPrint:        LD      A,(HL)
                CP      $FF
                JR      Z,EndPrint
                CALL    CharOut
                INC     HL
                JR      HLPrint
EndPrint:       INC     HL
                RET

CharOut:        PUSH    HL
                PUSH    DE
                PUSH    BC
                LD      HL,ControlBits
                BIT     0,(HL)
                JP      NZ,DoXPos
                BIT     1,(HL)
                JP      NZ,DoYPos
                BIT     2,(HL)
                JP      NZ,CCSetAttr
                BIT     3,(HL)
                JP      NZ,CCSpaces
                CP      $20
                JR      C,ControlChar
                OR      A
                JP      P,NotToken
                CALL    ExpandToken
                JR      EndCharOut
NotToken:       LD      L,A
                LD      H,$00
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                LD      DE,CharSet
                ADD     HL,DE
                EX      DE,HL
                LD      HL,(PrintPos)
                LD      B,$08
DrawCharLoop:   LD      A,(DE)
                LD      (HL),A
                INC     DE
                INC     H
                DJNZ    DrawCharLoop
                LD      HL,(PrintPos)
                INC     HL
                LD      (PrintPos),HL
                LD      HL,(AttrPos)
                LD      A,(Attribute)
                LD      (HL),A
                INC     HL
                LD      (AttrPos),HL
EndCharOut:     POP     BC
                POP     DE
                POP     HL
                RET

ControlChar:    CP      $02
                JR      Z,ClearScreen
                CP      $0D
                JR      Z,CCReturn
                LD      (ControlBits),A
                JP      EndCharOut

CCReturn:       LD      HL,YPos
                INC     (HL)
                XOR     A
                LD      (XPos),A
                JP      CalcScnPos

ClearScreen:    LD      HL,$4000
                LD      DE,$4001
                LD      BC,$1AFF
                LD      A,$00
                LD      (HL),A
                LDIR
                OUT     ($FE),A
                LD      (XPos),A
                LD      (YPos),A
                JP      CalcScnPos

CCSpaces:       RES     3,(HL)
                LD      B,A
SpcLoop:        LD      A," "
                CALL    CharOut
                DJNZ    SpcLoop
                JP      EndCharOut

DoXPos:         RES     0,(HL)
                LD      (XPos),A
                JP      EndCharOut

DoYPos:         RES     1,(HL)
                LD      (YPos),A
CalcScnPos:     LD      A,(YPos)
                LD      B,A
                LD      L,B
                LD      A,(XPos)
                LD      C,A
                LD      H,000
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                LD      D,$58
                LD      E,C
                ADD     HL,DE
                LD      (AttrPos),HL
                LD      A,B
                AND     $07
                ADD     A,A
                ADD     A,A
                ADD     A,A
                ADD     A,A
                ADD     A,A
                ADD     A,C
                LD      L,A
                LD      A,B
                AND     $18
                ADD     A,$40
                LD      H,A
                LD      (PrintPos),HL
                JP      EndCharOut

CCSetAttr:      RES     2,(HL)
                LD      (Attribute),A
                JP      EndCharOut

ExpandToken:    AND     $7F
                CALL    Search
ExpandLoop:     LD      A,(HL)
                OR      A
                RET     Z
                CALL    CharOut
                INC     HL
                JP      ExpandLoop

Search:         LD      B,A
                LD      HL,TokenTable
                OR      A
                RET     Z
SearchLoop:     LD      A,(HL)
                INC     HL
                OR      A
                JR      NZ,SearchLoop
                DJNZ    SearchLoop
                RET

TokenTable:     DEFB    "1 ",$00
                DEFB    "2 ",$00
                DEFB    "3 ",$00
                DEFB    "4 ",$00
                DEFB    "5 ",$00
                DEFB    "Nosferatu",$00
                DEFB    "the ",$00
                DEFB    "Play ",$00
                DEFB    " game",$00
                DEFB    " GAME",$00
                DEFB    "elect",$00
                DEFB    "Joystick ",$00
                DEFB    "Instructions",$00
                DEFB    "resent",$00
                DEFB    "Pick/Drop/Swap",$00
                DEFB    "Unlock/Fight",$00
                DEFB    "eturn to ",$86,"main menu",$00
                DEFB    "Congratulations you have ",$00
                DEFB    "Space",$00
                DEFB    "Caps Shift",$00
                DEFB    "Enter",$00
                DEFB    "Sym Shift",$00

                segment data
AttrPos:        DEFW    $5800
PrintPos:       DEFW    $4000
Attribute:      DEFB    $00
XPos:           DEFB    $00
YPos:           DEFB    $00
ControlBits:    DEFB    $00
                segment code
