                segment code

EvenMaskLine    MACRO(Across)
                loop    (Across/2)-$01
                POP     BC
                LD      E,C
                LD      A,(DE)
                AND     (HL)
                OR      E
                LD      (HL),A
                INC     HL
                LD      E,B
                LD      A,(DE)
                AND     (HL)
                OR      E
                LD      (HL),A
                INC     HL
                lend
                POP     BC
                LD      E,C
                LD      A,(DE)
                AND     (HL)
                OR      E
                LD      (HL),A
                INC     HL
                LD      E,B
                LD      A,(DE)
                AND     (HL)
                OR      E
                LD      (HL),A
                EXX
                ADD     HL,BC
                LD      SP,HL
                EXX
                IF      $02*DummyWidth+$01-Across >= $05
                LD      A,L
                ADD     A,$02*DummyWidth+$01-Across
                LD      L,A
                ADC     A,H
                SUB     L
                LD      H,A
                ELSE
                loop    $02*DummyWidth+$01-Across
                INC     HL
                lend
                ENDIF
                ENDM

OddMaskLine     MACRO(Across)
                loop    ((Across+$01)/2)-$01
                POP     BC
                LD      E,C
                LD      A,(DE)
                AND     (HL)
                OR      E
                LD      (HL),A
                INC     HL
                LD      E,B
                LD      A,(DE)
                AND     (HL)
                OR      E
                LD      (HL),A
                INC     HL
                lend
                POP     BC
                LD      E,C
                LD      A,(DE)
                AND     (HL)
                OR      E
                LD      (HL),A
                EXX
                ADD     HL,BC
                LD      SP,HL
                EXX
                IF      $02*DummyWidth+$01-Across >= $05
                LD      A,L
                ADD     A,$02*DummyWidth+$01-Across
                LD      L,A
                ADC     A,H
                SUB     L
                LD      H,A
                ELSE
                loop    $02*DummyWidth+$01-Across
                INC     HL
                lend
                ENDIF
                ENDM

MaskSprite:     LD      L,A
                RES     7,L
                PUSH    BC
                LD      H,HIGH SprSet
                LD      E,(HL)
                SET     7,L
                LD      D,(HL)
                RES     7,L
                INC     H
                LD      B,(HL)
                PUSH    DE                      ;Sprite pointer
                SET     7,L
                XOR     (HL)
                AND     $80
                LD      C,A
                EX      AF,AF'
                LD      A,(HL)
                XOR     C
                LD      (HL),A
                AND     $7F
                LD      C,A
                POP     HL                      ;HL' = Sprite pointer
                PUSH    BC
                LD      B,$00
                EXX
                POP     DE
                EX      AF,AF'
                CALL    NZ,Reverse
                POP     HL                      ;HL = Sprite pos Y,X
                SLA     E
                LD      BC,(SizeWindX)

                ;H=Sprite Pos Y
                ;L=Sprite Pos X
                ;D=Height in 1 bit slices
                ;E=Width  in 2 bit slices
                ;B=Height of window in 1 bit slices
                ;C=Width  of window in 2 bit slices
                ;HL'=Sprite Pointer
                ;BC'=Add Width

                LD      A,H
                OR      A
                JP      P,NoTopClipSprite
                ADD     A,D
                LD      D,A
                RET     NC
                RET     Z
                LD      A,H
                NEG
                EXX
TopClipLp:      ADD     HL,BC
                DEC     A
                JR      NZ,TopClipLp
                EXX
                LD      H,A
NoTopClipSprite:ADD     A,D
                SUB     B
                JR      Z,NoBottClipSprite
                JR      C,NoBottClipSprite
                NEG
                ADD     A,D
                RET     NC
                RET     Z
                LD      D,A
NoBottClipSprite:BIT     0,L
                CALL    NZ,Rotate
                LD      A,L
                OR      A
                JP      P,NoLeftClipSprite
                ADD     A,E
                LD      E,A
                LD      A,L
                RRA
                NEG
                EXX
                ADD     A,L
                LD      L,A
                ADC     A,H
                SUB     L
                LD      H,A
                EXX
                XOR     A
                LD      L,A
NoLeftClipSprite:ADD     A,E
                SUB     C
                JR      Z,NoRightClipSprite
                JR      C,NoRightClipSprite
                NEG
                ADD     A,E
                LD      E,A

/*

Height to draw 1 bit slices     D
Width to draw  2 bit slices     E
Position X                      L
Position Y                      H
Sprite pointer                  HL'
Addition width                  BC'
*/


NoRightClipSprite:
                LD      A,D
                EX      AF,AF'
                LD      A,E
                EX      DE,HL
                AND     $FE
                ADD     A,LOW SpriteDrawTable
                LD      L,A
                ADC     A,HIGH SpriteDrawTable
                SUB     L
                LD      H,A
                LD      A,(HL)
                INC     HL
                LD      H,(HL)
                LD      L,A
                PUSH    HL                      ;Sprite routine pointer
                SRA     E
                LD      H,$00
                LD      A,D
                ADD     A,A
                ADD     A,A
                ADD     A,D
                ADD     A,A
                RL      H
                LD      L,A
                LD      D,HIGH DummyScreen
                ADD     HL,DE
                LD      D,HIGH MaskTable
                EX      AF,AF'
ReturnMask:     RET

SpriteDrawTable:DEFW    ReturnMask,Mask001
                DEFW    Mask002,Mask003
                DEFW    Mask004,Mask005
                DEFW    Mask006,Mask007
                DEFW    Mask008,Mask009
                DEFW    Mask00A

Mask001:        EXX
                LD      (Stack001),SP
                DI
                LD      SP,HL
                EXX
MaskLoop1:      EX      AF,AF'
                OddMaskLine(1)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop1
                LD      SP,$0000
Stack001        EQU     $-$02
                EI
                RET

Mask002:        EXX
                LD      (Stack002),SP
                DI
                LD      SP,HL
                EXX
MaskLoop2:      EX      AF,AF'
                EvenMaskLine(2)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop2
                LD      SP,$0000
Stack002        EQU     $-$02
                EI
                RET

Mask003:        EXX
                LD      (Stack003),SP
                DI
                LD      SP,HL
                EXX
MaskLoop3:      EX      AF,AF'
                OddMaskLine(3)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop3
                LD      SP,$0000
Stack003        EQU     $-$02
                EI
                RET

Mask004:        EXX
                LD      (Stack004),SP
                DI
                LD      SP,HL
                EXX
MaskLoop4:      EX      AF,AF'
                EvenMaskLine(4)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop4
                LD      SP,$0000
Stack004        EQU     $-$02
                EI
                RET

Mask005:        EXX
                LD      (Stack005),SP
                DI
                LD      SP,HL
                EXX
MaskLoop5:      EX      AF,AF'
                OddMaskLine(5)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop5
                LD      SP,$0000
Stack005        EQU     $-$02
                EI
                RET

Mask006:        EXX
                LD      (Stack006),SP
                DI
                LD      SP,HL
                EXX
MaskLoop6:      EX      AF,AF'
                EvenMaskLine(6)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop6
                LD      SP,$0000
Stack006        EQU     $-$02
                EI
                RET

Mask007:        EXX
                LD      (Stack007),SP
                DI
                LD      SP,HL
                EXX
MaskLoop7:      EX      AF,AF'
                OddMaskLine(7)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop7
                LD      SP,$0000
Stack007        EQU     $-$02
                EI
                RET

Mask008:        EXX
                LD      (Stack008),SP
                DI
                LD      SP,HL
                EXX
MaskLoop8:      EX      AF,AF'
                EvenMaskLine(8)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop8
                LD      SP,$0000
Stack008        EQU     $-$02
                EI
                RET

Mask009:        EXX
                LD      (Stack009),SP
                DI
                LD      SP,HL
                EXX
MaskLoop9:      EX      AF,AF'
                OddMaskLine(9)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoop9
                LD      SP,$0000
Stack009        EQU     $-$02
                EI
                RET

Mask00A:        EXX
                LD      (Stack00A),SP
                DI
                LD      SP,HL
                EXX
MaskLoopA:      EX      AF,AF'
                EvenMaskLine(10)
                EX      AF,AF'
                DEC     A
                JP      NZ,MaskLoopA
                LD      SP,$0000
Stack00A        EQU     $-$02
                EI
                RET

                segment sprites
                import_bin "NosSprites.bin",SprSet
                segment code
